puts "CATALLACTIC APPROACH"
puts "Constructing a network of 100 nodes"

cd [mkdir drcl.comp.Component /test]

puts "Define and open database..."
#Syntax: opendatabase "host" "username" "password" "Name of Experiment"
#java::call catnet.log.store opendatabase "drewpc2.iig.uni-freiburg.de/CatNet_Data" "cn" "CatNet" "Cat_01"

puts "Create topology..."

set link_ [java::new drcl.inet.Link]
$link_ setPropDelay 0.01

# Variables
set level1 3
set level2 3
set nclients 1
set nscs 1
set level3 [expr $nclients]
set numnodes [expr $level1 + (($level2)-1)*$level1 + $level1*(($level2)-1)*$level3]

# adjacency matrix
set adjMatrix_ [java::new int\[\]\[\] [expr $numnodes + 1]]

set currlvl2 [expr $level1]
set currlvl3 [expr $level1*$level2]
$adjMatrix_ set [expr $numnodes] [java::new int\[\] [expr $level1]]
for {set i 0} {$i<$level1} {incr i} {

  # Creamos la adyacencia para el nodo del pentagono central
  $adjMatrix_ set [expr $i] [java::new int\[\] 5]
  [$adjMatrix_ get [expr $i]] set 0 [expr ($i + 1)%$level1]
  [$adjMatrix_ get [expr $i]] set 1 [expr ($i - 1)%$level1]
  [$adjMatrix_ get [expr $i]] set 2 [expr $level1 + $i*($level2-1)]
  [$adjMatrix_ get [expr $i]] set 3 [expr $level1 + ($i + 1)*($level2-1) -1]
  # Creamos la adyacencia para el nodo central
  [$adjMatrix_ get [expr $numnodes]] set [expr $i] [expr $i]
  [$adjMatrix_ get [expr $i]] set 4 [expr $numnodes]
  
  # Creamos la adyacencia para los subpentagonos  
  for {set j 0} {$j<($level2 - 1)} {incr j} {
    $adjMatrix_ set [expr $currlvl2] [java::new int\[\] [expr 2 + $level3]]
    # Si es el primer nodo del subpentagono
    if {$j == 0} {
      [$adjMatrix_ get [expr $currlvl2]] set 0 [expr $i] 
    } else {
      [$adjMatrix_ get [expr $currlvl2]] set 0 [expr ($currlvl2 - 1)] 
    }
    # Si es el ultimo nodo del subpentagono
    if {$j == ($level2 - 2)} {
      [$adjMatrix_ get [expr $currlvl2]] set 1 [expr $i] 
    } else {
      [$adjMatrix_ get [expr $currlvl2]] set 1 [expr $currlvl2 + 1] 
    }

    # Creamos la adyacencia de los vertices de los subpentagonos
    for {set k 0} {$k<$level3} {incr k} {
      [$adjMatrix_ get [expr $currlvl2]] set [expr 2 + $k] [expr $currlvl3] 
      $adjMatrix_ set [expr $currlvl3] [java::new int\[\] 1]
      [$adjMatrix_ get [expr $currlvl3]] set 0 [expr $currlvl2] 
    
      set currlvl3 [expr $currlvl3 + 1]
    }

    set currlvl2 [expr $currlvl2 + 1]
  }
}

java::call drcl.inet.InetUtil createTopology [! .] "n" "n" $adjMatrix_ $link_

puts "Building..."
set nb_ [mkdir drcl.inet.NodeBuilder .nb]
$nb_ setBandwidth 1000000; # 10Mbps

$nb_ build [! n*]

set starth [expr $level1*$level2]
# Por ahora todos los nodos de los pentagonos son resources
# y los de los anillos exteriores tiene servicecopies
for {set i 0} {$i<($starth)} {incr i} {
    $nb_ build [! n$i] {
	udp			 drcl.inet.transport.UDP
  	resource  101/udp 	catnet.resource.Resource
	servicecopy102 102/udp catnet.servicecopy.ServiceCopy
    }
}

# En las hojas ponemos clientes
for {set i [expr $starth]} {$i<($numnodes)} {incr i} {
  if {(($i-$starth) % $level3) < $nclients} {
    $nb_ build [! n$i] {
	udp			drcl.inet.transport.UDP
	client 101/udp 	 	catnet.client.Client
    }
  }
}

$nb_ build [! n$numnodes] {
  udp			drcl.inet.transport.UDP
  MSC1 101/udp 		catnet.servicecopy.MasterServiceCopy
  MSC2 102/udp 		catnet.servicecopy.MasterServiceCopy
}


# Para los resources internos
for {set i 0} {$i<($starth)} {incr i} {
  ! n$i/resource setHP $i 101
#  set tmpport [expr (($i-$starth) % $level3) - $nclients + 101 + 1]
  ! n$i/servicecopy102 setHP $i 102
#  ! n$i/servicecopy103 setHP $i 103
#  ! n$i/servicecopy103 setMasterServiceCopy $numnodes
}

for {set i [expr $starth]} {$i<($numnodes)} {incr i} {
  # Client
  if {(($i-$starth) % $level3) < $nclients} {
    ! n$i/client setHP $i 101
  }
}

! n$i/MSC1 setHP $numnodes 101
! n$i/MSC2 setHP $numnodes 102

puts "Setup static routes ..."
set currlvl2 [expr $level1]
set currlvl3 [expr $level1*$level2]
for {set i 0} {$i<$level1} {incr i} {
  ! n$i/resource setknownResources [expr ($i - 1)%$level1]
  ! n$i/resource setknownResources [expr ($i + 1)%$level1]
  ! n$i/resource setknownResources [expr $currlvl2]
  ! n$i/resource setknownResources [expr $currlvl2 + $level2 - 2]

  for {set j 0} {$j<($level2 - 1)} {incr j} {
    set temp [expr ($currlvl2)+1]
    # Ultimo nodo del subpentagono
    if {$j == ($level2 - 2)} {
      ! n$currlvl2/resource setknownResources [expr $i]
      ! n$currlvl2/resource setknownResources [expr $currlvl2 - 1]
    # Primer nodo del subpentagono
    } elseif {$j == 0} {
      ! n$currlvl2/resource setknownResources [expr $i]
      ! n$currlvl2/resource setknownResources [expr $currlvl2 + 1]
    # Nodos restantes del subpentagono
    } else {
      ! n$currlvl2/resource setknownResources [expr ($currlvl2) - 1]
      ! n$currlvl2/resource setknownResources [expr ($currlvl2) + 1]
    }
  
    # Creamos las rutas de los nodos finales
    for {set k 0} {$k<$level3} {incr k} {
      java::call drcl.inet.InetUtil setupRoutes [! n$currlvl2] [! n$currlvl3] "bidirection"
      set currlvl3 [expr $currlvl3 + 1]
    }
    set currlvl2 [expr $currlvl2 + 1]
  }
}

#for {set i 0} {$i<$level1*$level2} {incr i} {
#  for {set j [expr $i+1]} {$j<$level1*$level2} {incr j} {
#    java::call drcl.inet.InetUtil setupRoutes [! n$i] [! n$j] "bidirection"
#  }
#  for {set j [expr $level1*$level2]} {$j<$numnodes} {incr j} {
#    java::call drcl.inet.InetUtil setupRoutes [! n$i] [! n$j] "bidirection"
#  }
#}


for {set i 0} {$i<$numnodes + 1} {incr i} {
  for {set j [expr $i+1]} {$j<$numnodes + 1} {incr j} {
    java::call drcl.inet.InetUtil setupRoutes [! n$i] [! n$j] "bidirection"
  }
}

for {set i 0} {$i<$numnodes} {incr i} {
    java::call drcl.inet.InetUtil setupRoutes [! n$i] [! n$numnodes] "bidirection"
}
