puts "CATALLACTIC APPROACH"
puts "Constructing a network of 1000 nodes"

cd [mkdir drcl.comp.Component /test]

puts "Define and open database..."
#Syntax: opendatabase "host" "username" "password" "Name of Experiment"
#java::call catnet.log.store opendatabase "drewpc2.iig.uni-freiburg.de/CatNet_Data" "cn" "CatNet" "Cat_01"

puts "Create topology..."

set link_ [java::new drcl.inet.Link]
$link_ setPropDelay 0.01

# Variables
set level1 3
set level2 2
set level3 8
set level4 3
set numnodes [expr $level1 + $level2*$level1 + $level1*$level2*($level3 - 1)*($level4 + 1)]

# adjacency matrix
set adjMatrix_ [java::new int\[\]\[\] [expr $numnodes + 1]]

set currlvl2 [expr $level1]
set currlvl3 [expr $level1*($level2 + 1)]
set currlvl4 [expr $level1 + $level3*$level2*$level1]
$adjMatrix_ set [expr $numnodes] [java::new int\[\] [expr $level1]]
for {set i 0} {$i<$level1} {incr i} {
  # Creamos la adyacencia para el nodo del pentagono central
  $adjMatrix_ set [expr $i] [java::new int\[\] [expr 3 + $level2]]
  [$adjMatrix_ get [expr $i]] set 0 [expr ($i + 1)%$level1]
  [$adjMatrix_ get [expr $i]] set 1 [expr ($i - 1)%$level1]
  for {set j 0} {$j<$level2} {incr j} {
    [$adjMatrix_ get [expr $i]] set [expr 2 + $j] [expr $level1 + $i*$level2 + $j]
  }
  # Creamos la adyacencia para el nodo central
  [$adjMatrix_ get [expr $numnodes]] set [expr $i] [expr $i]
  [$adjMatrix_ get [expr $i]] set 4 [expr $numnodes]
  
  # Creamos la adyacencia para el segundo anillo central
  for {set j 0} {$j<$level2} {incr j} {
    $adjMatrix_ set [expr $currlvl2] [java::new int\[\] 5]

    [$adjMatrix_ get [expr $currlvl2]] set 0 [expr $i] 
    [$adjMatrix_ get [expr $currlvl2]] set 1 [expr ($currlvl2 + 1 - $level1)%($level2*$level1) + $level1] 
    [$adjMatrix_ get [expr $currlvl2]] set 2 [expr ($currlvl2 - 1 - $level1)%($level2*$level1) + $level1] 
    [$adjMatrix_ get [expr $currlvl2]] set 3 [expr $level1*($level2 + 1) + ($i*$level2 + $j)*($level3 - 1)] 
    [$adjMatrix_ get [expr $currlvl2]] set 4 [expr $level1*($level2 + 1) + ($i*$level2 + $j)*($level3 - 1) + ($level3 - 2)] 
    
    # Creamos la adyacencia para el segundo anillo central
    for {set k 0} {$k<($level3 - 1)} {incr k} {
      $adjMatrix_ set [expr $currlvl3] [java::new int\[\] [expr 2 + $level4]]
      
      # Miramos si es el "primer" nodo del anillo exterior
      if {$k == 0} {
        [$adjMatrix_ get [expr $currlvl3]] set 0 [expr $currlvl2] 
      } else {
        [$adjMatrix_ get [expr $currlvl3]] set 0 [expr ($currlvl3 - 1)] 
      }
      # Miramos si es el "ltimo" nodo del anillo exterior
      if {$k == ($level3 - 2)} {
        [$adjMatrix_ get [expr $currlvl3]] set 1 [expr $currlvl2] 
      } else {
        [$adjMatrix_ get [expr $currlvl3]] set 1 [expr $currlvl3 + 1] 
      }
  
      # Creamos la adyacencia para las hojas    
      for {set l 0} {$l < $level4} {incr l} {
        $adjMatrix_ set [expr $currlvl4] [java::new int\[\] 1]

        [$adjMatrix_ get [expr $currlvl4]] set 0 [expr $currlvl3] 
        [$adjMatrix_ get [expr $currlvl3]] set [expr 2 + $l] [expr $currlvl4] 
      	
        set currlvl4 [expr $currlvl4 + 1]
        }
      
      set currlvl3 [expr $currlvl3 + 1]

      }    
    set currlvl2 [expr $currlvl2 + 1]
    }
  }

java::call drcl.inet.InetUtil createTopology [! .] "n" "n" $adjMatrix_ $link_

puts "Building..."
set nb_ [mkdir drcl.inet.NodeBuilder .nb]
$nb_ setBandwidth 1000000; # 10Mbps

$nb_ build [! n*]

set starth [expr $level1*($level2+1) + $level1*$level2*($level3 - 1)]
for {set i 0} {$i<($starth)} {incr i} {
    $nb_ build [! n$i] {
	udp			 drcl.inet.transport.UDP
  	resource  101/udp 	catnet.resource.Resource
	servicecopy103 103/udp catnet.servicecopy.ServiceCopy
    }
}

# En las hojas ponemos clientes
for {set i [expr $starth]} {$i<($numnodes)} {incr i} {
  $nb_ build [! n$i] {
	udp			drcl.inet.transport.UDP
  	resource  101/udp 	catnet.resource.Resource
	client 102/udp 	 	catnet.client.Client
	servicecopy103 103/udp catnet.servicecopy.ServiceCopy
  }
}

$nb_ build [! n$numnodes] {
  udp			drcl.inet.transport.UDP
  MSC1 101/udp 		catnet.servicecopy.MasterServiceCopy
  MSC2 102/udp 		catnet.servicecopy.MasterServiceCopy
}


# Para los resources internos
for {set i 0} {$i<($starth)} {incr i} {
  ! n$i/resource setHP $i 101
  ! n$i/servicecopy103 setHP $i 103
}

for {set i [expr $starth]} {$i<($numnodes)} {incr i} {
  # Client
  ! n$i/resource setHP $i 101
  ! n$i/client setHP $i 102
  ! n$i/servicecopy103 setHP $i 103
}

! n$i/MSC1 setHP $numnodes 101
! n$i/MSC2 setHP $numnodes 102

puts "Setup broadcast routes ..."
set currlvl2 [expr $level1]
set currlvl3 [expr $level1*($level2 + 1)]
set currlvl4 [expr $level1 + $level3*$level2*$level1]
for {set i 0} {$i<$level1} {incr i} {
  ! n$i/resource setknownResources [expr ($i - 1)%$level1]
  ! n$i/resource setknownResources [expr ($i + 1)%$level1]
#  ! n$i/resource setknownResources [expr $numnodes]
#  ! n$numnodes/resource setknownResources [expr $i]

  # Creamos la adyacencia para el nodo del pentagono central
  for {set j 0} {$j<$level2} {incr j} {
    ! n$i/resource setknownResources [expr $level1 + $i*$level2 + $j]
  }

  # Creamos la adyacencia para el segundo anillo central
  for {set j 0} {$j<$level2} {incr j} {
    ! n$currlvl2/resource setknownResources [expr $i] 
    ! n$currlvl2/resource setknownResources [expr ($currlvl2 + 1 - $level1)%($level2*$level1) + $level1] 
    ! n$currlvl2/resource setknownResources [expr ($currlvl2 - 1 - $level1)%($level2*$level1) + $level1] 
    ! n$currlvl2/resource setknownResources [expr $level1*($level2 + 1) + ($i*$level2 + $j)*($level3 - 1)] 
    ! n$currlvl2/resource setknownResources [expr $level1*($level2 + 1) + ($i*$level2 + $j)*($level3 - 1) + ($level3 - 2)] 
    
    # Creamos la adyacencia para el segundo anillo central
    for {set k 0} {$k<($level3 - 1)} {incr k} {
      # Miramos si es el "primer" nodo del anillo exterior
      if {$k == 0} {
        ! n$currlvl3/resource setknownResources [expr $currlvl2] 
      } else {
        ! n$currlvl3/resource setknownResources [expr ($currlvl3 - 1)] 
      }
      # Miramos si es el "ltimo" nodo del anillo exterior
      if {$k == ($level3 - 2)} {
        ! n$currlvl3/resource setknownResources [expr $currlvl2] 
      } else {
        ! n$currlvl3/resource setknownResources [expr $currlvl3 + 1] 
      }
  
      # Creamos la adyacencia para las hojas    
      for {set l 0} {$l < $level4} {incr l} {
        ! n$currlvl4/resource setknownResources [expr $currlvl3] 
        ! n$currlvl3/resource setknownResources [expr $currlvl4] 
      	
        set currlvl4 [expr $currlvl4 + 1]
        }
      
      set currlvl3 [expr $currlvl3 + 1]

      }    
    set currlvl2 [expr $currlvl2 + 1]
    }
  }

puts "Setup static routes ..."
for {set i 0} {$i<$numnodes + 1} {incr i} {
  for {set j [expr $i+1]} {$j<$numnodes + 1} {incr j} {
    java::call drcl.inet.InetUtil setupRoutes [! n$i] [! n$j] "bidirection"
  }
}
