puts "CATALLACTIC APPROACH"
puts "Constructing a network of 100 nodes"

cd [mkdir drcl.comp.Component /test]

puts "Define and open database..."
#Syntax: opendatabase "host" "username" "password" "Name of Experiment"
#java::call catnet.log.store opendatabase "drewpc2.iig.uni-freiburg.de/CatNet_Data" "cn" "CatNet" "Cat_01"

puts "Create topology..."

set link_ [java::new drcl.inet.Link]
$link_ setPropDelay 0.01

# Variables
set level1 5
set level2 6
set nclients 3
set nscs 1
set level3 [expr $nclients]
set numnodes [expr $level1 + (($level2)-1)*$level1 + $level1*(($level2)-1)*$level3]

# adjacency matrix
set adjMatrix_ [java::new int\[\]\[\] [expr $numnodes + 1]]

set currlvl2 [expr $level1]
set currlvl3 [expr $level1*$level2]
$adjMatrix_ set [expr $numnodes] [java::new int\[\] [expr $level1]]
for {set i 0} {$i<$level1} {incr i} {

  # Creamos la adyacencia para el nodo del pentagono central
  $adjMatrix_ set [expr $i] [java::new int\[\] 5]
  [$adjMatrix_ get [expr $i]] set 0 [expr ($i + 1)%$level1]
  [$adjMatrix_ get [expr $i]] set 1 [expr ($i - 1)%$level1]
  [$adjMatrix_ get [expr $i]] set 2 [expr $level1 + $i*($level2-1)]
  [$adjMatrix_ get [expr $i]] set 3 [expr $level1 + ($i + 1)*($level2-1) -1]
  # Creamos la adyacencia para el nodo central
  [$adjMatrix_ get [expr $numnodes]] set [expr $i] [expr $i]
  [$adjMatrix_ get [expr $i]] set 4 [expr $numnodes]
  
  # Creamos la adyacencia para los subpentagonos  
  for {set j 0} {$j<($level2 - 1)} {incr j} {
################################################3  	
    if {$j == (($level2/2) - 1)} {
      set numVeins [expr 2 + $level2 - 2 + $level3]
      $adjMatrix_ set [expr $currlvl2] [java::new int\[\] [expr $numVeins]]

      set currPos [expr 2 + $level3]
      for {set punta 0} {$punta<$level1} {incr punta} {
        set currNode [expr $level1 + ($level2/2) + (($level2 - 1)*$punta) - 1]
      	if {$currNode != $currlvl2} {
          [$adjMatrix_ get [expr $currlvl2]] set [expr $currPos] [expr $currNode] 
          set currPos [expr $currPos + 1]
        }
      }
################################################3  	
    } else {
      $adjMatrix_ set [expr $currlvl2] [java::new int\[\] [expr 2 + $level3]]
    }

    # Si es el primer nodo del subpentagono
    if {$j == 0} {
      [$adjMatrix_ get [expr $currlvl2]] set 0 [expr $i] 
    } else {
      [$adjMatrix_ get [expr $currlvl2]] set 0 [expr ($currlvl2 - 1)] 
    }
    # Si es el ultimo nodo del subpentagono
    if {$j == ($level2 - 2)} {
      [$adjMatrix_ get [expr $currlvl2]] set 1 [expr $i] 
    } else {
      [$adjMatrix_ get [expr $currlvl2]] set 1 [expr $currlvl2 + 1] 
    }

    # Creamos la adyacencia de los vertices de los subpentagonos
    for {set k 0} {$k<$level3} {incr k} {
      [$adjMatrix_ get [expr $currlvl2]] set [expr 2 + $k] [expr $currlvl3] 
      $adjMatrix_ set [expr $currlvl3] [java::new int\[\] 1]
      [$adjMatrix_ get [expr $currlvl3]] set 0 [expr $currlvl2] 
    
      set currlvl3 [expr $currlvl3 + 1]
    }

    set currlvl2 [expr $currlvl2 + 1]
  }
}

java::call drcl.inet.InetUtil createTopology [! .] "n" "n" $adjMatrix_ $link_

puts "Building..."
set nb_ [mkdir drcl.inet.NodeBuilder .nb]
$nb_ setBandwidth 1000000; # 10Mbps

$nb_ build [! n*]

set starth [expr $level1*$level2]
for {set i 0} {$i<($starth)} {incr i} {
    $nb_ build [! n$i] {
	udp			 drcl.inet.transport.UDP
  	resource  101/udp 	catnet.resource.Resource
	servicecopy103 103/udp catnet.servicecopy.ServiceCopy
    }
}

# En las hojas ponemos clientes
for {set i [expr $starth]} {$i<($numnodes)} {incr i} {
  $nb_ build [! n$i] {
	udp			drcl.inet.transport.UDP
  	resource  101/udp 	catnet.resource.Resource
	client 102/udp 	 	catnet.client.Client
	servicecopy103 103/udp catnet.servicecopy.ServiceCopy
  }
}

$nb_ build [! n$numnodes] {
  udp			drcl.inet.transport.UDP
  MSC1 101/udp 		catnet.servicecopy.MasterServiceCopy
  MSC2 102/udp 		catnet.servicecopy.MasterServiceCopy
}


# Para los resources internos
for {set i 0} {$i<($starth)} {incr i} {
  ! n$i/resource setHP $i 101
  ! n$i/servicecopy103 setHP $i 103
}

for {set i [expr $starth]} {$i<($numnodes)} {incr i} {
  # Client
  ! n$i/resource setHP $i 101
  ! n$i/client setHP $i 102
  ! n$i/servicecopy103 setHP $i 103
}

! n$i/MSC1 setHP $numnodes 101
! n$i/MSC2 setHP $numnodes 102

puts "Setup broadcast routes ..."
set currlvl2 [expr $level1]
set currlvl3 [expr $level1*$level2]
for {set i 0} {$i<$level1} {incr i} {
  ! n$i/resource setknownResources [expr ($i - 1)%$level1]
  ! n$i/resource setknownResources [expr ($i + 1)%$level1]
  ! n$i/resource setknownResources [expr $currlvl2]
  ! n$i/resource setknownResources [expr $currlvl2 + $level2 - 2]
#  ! n$i/resource setknownResources [expr $numnodes]
#  ! n$numnodes/resource setknownResources [expr $i]

  for {set j 0} {$j<($level2 - 1)} {incr j} {
    set temp [expr ($currlvl2)+1]
    # Ultimo nodo del subpentagono
    if {$j == ($level2 - 2)} {
      ! n$currlvl2/resource setknownResources [expr $i]
      ! n$currlvl2/resource setknownResources [expr $currlvl2 - 1]
    # Primer nodo del subpentagono
    } elseif {$j == 0} {
      ! n$currlvl2/resource setknownResources [expr $i]
      ! n$currlvl2/resource setknownResources [expr $currlvl2 + 1]
    # Nodos restantes del subpentagono
    } else {
      ! n$currlvl2/resource setknownResources [expr ($currlvl2) - 1]
      ! n$currlvl2/resource setknownResources [expr ($currlvl2) + 1]
    }
    
#########################################
    if {$j == (($level2/2) - 1)} {
      for {set punta 0} {$punta<$level1} {incr punta} {
        set currNode [expr $level1 + ($level2/2) + (($level2 - 1)*$punta) - 1]
      	if {$currNode != $currlvl2} {
          ! n$currlvl2/resource setknownResources [expr $currNode]
#          [$adjMatrix_ get [expr $currlvl2]] set [expr $currPos] [expr $currNode] 
        }
      }
    }
#########################################    


    # Creamos las rutas de los nodos finales
    for {set k 0} {$k<$level3} {incr k} {
      ! n$currlvl3/resource setknownResources [expr $currlvl2]
      ! n$currlvl2/resource setknownResources [expr $currlvl3]
      set currlvl3 [expr $currlvl3 + 1]
    }
    set currlvl2 [expr $currlvl2 + 1]
  }
}

puts "Setup static routes ..."
for {set i 0} {$i<$numnodes + 1} {incr i} {
  for {set j [expr $i+1]} {$j<$numnodes + 1} {incr j} {
    java::call drcl.inet.InetUtil setupRoutes [! n$i] [! n$j] "bidirection"
  }
}