package catnet.accounting;

import java.util.Date;
/**
 *  berschrift: B2B-OS Beschreibung: Copyright: Copyright (c) 2001
 *  Organisation: IIG Telematik, Albert-Ludwigs-Universitaet Freiburg
 *
 *@author     Dr. Torsten Eymann
 *@created    5. Dezember 2001
 *@version    1.0
 */

public class StockLineItem extends Factor {

    /**
     *  Description of the Field
     */
    private int productQuantity = 0;

    /**
     *  Description of the Field
     */
    private int reservedQuantity = 0;
    /**
     *  Description of the Field
     */
    private Date inStorageTime;
    /**
     *  Description of the Field
     */
    public final static String[] sPropType = new String[]{"input", "output"};
    /**
     *  Description of the Field
     */
    private double unitValue;


    /**
     *  public StockLineItem(Factor f, int q, double d) { this.unitValue = d;
     *  this.productQuantity = q; this.inStorageTime = new Date();
     *  this.setProductIdentification(f.getProductIdentification()); }
     *
     *@param  q   Description of the Parameter
     *@param  d   Description of the Parameter
     *@param  id  Description of the Parameter
     */

    public StockLineItem(Integer id, int q, double d) {
        this.setProductIdentification(id);
        this.unitValue = d;
        this.productQuantity = q;
        this.reservedQuantity = 0;
        this.inStorageTime = new Date();
    }


    /**
     *  Gets the inStorageTime attribute of the StockLineItem object
     *
     *@return    The inStorageTime value
     */
    public Date getInStorageTime() {
        return inStorageTime;
    }


    /**
     *  Gets the productQuantity attribute of the StockLineItem object
     *
     *@return    The productQuantity value
     */
    public int getProductQuantity() {
        return productQuantity;
    }


    /**
     *  Sets the productQuantity attribute of the StockLineItem object
     *
     *@param  productQuantity  The new productQuantity value
     */
    public void setProductQuantity(int productQuantity) {
        this.productQuantity = productQuantity;
    }

    /**
     *  Sets the productQuantity attribute of the StockLineItem object
     *
     *@param  productQuantity  The new productQuantity value
     */
    public synchronized void addProductQuantity(int addProductQuantity, double addValue) {
    this.unitValue = (this.unitValue * this.productQuantity + addProductQuantity * addValue)
    /(productQuantity + addProductQuantity);
                        this.productQuantity += productQuantity;
    }



    /**
     *  Gets the availableQuantity attribute of the StockLineItem object
     *
     *@return    The availableQuantity value
     */
    public int getAvailableQuantity() {
        return (productQuantity - reservedQuantity);
    }


    /**
     *  Gets the reservedQuantity attribute of the StockLineItem object
     *
     *@return    The reservedQuantity value
     */
    public int getReservedQuantity() {
        return reservedQuantity;
    }


    /**
     *  Sets the reservedQuantity attribute of the StockLineItem object
     *
     *@param  reservedQuantity  The new reservedQuantity value
     */
    public void setReservedQuantity(int reservedQuantity) {
        this.reservedQuantity = reservedQuantity;
    }


    /**
     *  Gets the unitValue attribute of the StockLineItem object
     *
     *@return    The unitValue value
     */
    public double getUnitValue() {
        return unitValue;
    }


    /**
     *  Sets the unitValue attribute of the StockLineItem object
     *
     *@param  newValue  The feature to be added to the UnitValue attribute
     */
    public void addUnitValue(double newValue) {
    this.unitValue = (unitValue + newValue) / 2;
    }
}
