package catnet.client;

import catnet.agent.*;
import java.io.*;
import catnet.util.Hp;
import catnet.data.Msg;
import catnet.negotiation.PriceDistribution;
import catnet.util.IntCounter;
import catnet.data.Debug;
import catnet.data.constant;
import catnet.log.store;
import java.util.TreeMap;
import java.util.Vector;
import java.util.Map;
import catnet.util.TM_EVT;
import java.util.HashMap;
import catnet.negotiation.Conversation;
import catnet.learning.stdea.Genotype;
import catnet.learning.ILearning;
import catnet.learning.stdea.Plumage;

/**
 *  Description of the Class
 *
 *@author     eymann
 *@created    5. August 2002
 */
public class Client extends Agent_Source {
    
    public TreeMap pendingDemands;
    
    long knownResources[] = new long[MAX];
    /**
     *  Description of the Field
     */
    int knownResourcesNum = 0;
    
    private String CLASS_NAME="Client";
    
    /**
     *  Constructor for the Client object
     */
    public Client() {
        super();
        
        pendingDemands = new TreeMap();
        
        //Set tradeable itemIDs
        tradeable.addElement(new Integer(2));
        tradeable.addElement(new Integer(3));
        tradeable.addElement(new Integer(4));
        tradeable.addElement(new Integer(5));
        tradeable.addElement(new Integer(6));
        tradeable.addElement(new Integer(7));
        tradeable.addElement(new Integer(8));
        tradeable.addElement(new Integer(9));
        tradeable.addElement(new Integer(10));
        tradeable.addElement(new Integer(11));
        tradeable.addElement(new Integer(12));
        
        accept_plumage.addElement(new Integer(2));
        accept_plumage.addElement(new Integer(3));
        accept_plumage.addElement(new Integer(4));
        accept_plumage.addElement(new Integer(5));
        accept_plumage.addElement(new Integer(6));
        accept_plumage.addElement(new Integer(7));
        accept_plumage.addElement(new Integer(8));
        accept_plumage.addElement(new Integer(9));
        accept_plumage.addElement(new Integer(10));
        accept_plumage.addElement(new Integer(11));
        accept_plumage.addElement(new Integer(12));
        
    };
    
    public void setHP(long addr, int port) {
        LOCALHP.h = addr;
        LOCALHP.p = port;
        ownID = (int) (addr);
        
        //        readDemand(constant.demand_file);
    }
    
    protected void readDemand(String filename) {
        //Read demand
        String nameFile;
        File newFile;
        LineNumberReader lnr;
        FileReader fr;
        
        try {
            nameFile = filename;
            //            System.out.println("Reading demand "+nameFile);
            newFile = new File(nameFile);
            fr = new FileReader(newFile);
            lnr = new LineNumberReader(fr);
            
            int clientID;
            
            String str;
            while((str = lnr.readLine()) != null) {
                String[] strlist = str.split(new String("\\s"));
                clientID = Integer.valueOf(strlist[0]).intValue();
                if(ownID == clientID)  {
                    pendingDemands.put(Float.valueOf(strlist[2]), Integer.valueOf(strlist[1]));
                };
                
            };
            
        }
        catch (FileNotFoundException fnfe) {
            //System.out.println("Beginning: "+fnfe);
        }
        catch (IOException e) {
        };
        //        System.out.println("pending Demands ("+ownID+"): "+pendingDemands.toString());
    }
    
    /**
     *  Sets the knownResources attribute of the ServiceCopy object
     *
     *@param  n    The new knownResources value
     *@param  res  The new knownResources value
     */
    public void setKnownResources(int n, long[] res) {
        int i;
        for (i = 0; i < n; i++) {
            knownResources[i] = res[i];
        }
        knownResourcesNum = n;
    }
    
    
    //*******************************************************************************
    //CLIENT METHODS
    //*******************************************************************************
    
    /**
     *  Description of the Method
     *
     *@param  serviceID      Description of the Parameter
     *@param  amount         Description of the Parameter
     *@param  transactionId  Description of the Parameter
     *@param  timespan       Description of the Parameter
     *@param  money          Description of the Parameter
     */
    
    public synchronized void service_Demand(int serviceID) { //, int amount, Integer transactionId, int timespan, int money)
        // this function is called from a tracepool (or from the script at the beginning),
        //  it creates a request to be sent to a resource or service provider
        String METHOD_NAME="service_Demand";
        ableToStartDemand = false;
        
        if (checkRestrictions(serviceID)) {
            Integer Conversation_ID=new Integer(constant.conversation_counter++);
            store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, Conversation_ID, "Client " + ownID + " demands Service "+serviceID);
            //Add to openCfPs, will be checked on incoming CfPs from SCs
            openCfPs.addElement(Conversation_ID);
            //route service demand to all known resources
            for (int i = 0; i < knownResourcesNum; i++) {
                Msg res = new Msg();
                res.itemID = serviceID;
                res.sender_hp = this.LOCALHP;
                res.hop_counter=0;
                res.DocumentType=constant.ASK;
                res.broadcast=true;
                res.setRequestingClient(this.LOCALHP);
                store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, Conversation_ID, ownID+" sends Request to Resource "+knownResources[i]);
                Hp dest = new Hp(knownResources[i], 101);
                res.setConversation_ID(Conversation_ID);
                res.request_ID=res.getConversation_ID();
                if (isDebugEnabled()) { debug("Agent "+ownID+": conversation_ID "+res.getConversation_ID()+" allocated"); };
                res.receiver_hp = dest;
                
                //If Baseline then send Max Willingness to pay
                if (constant.m_baseline) res.BID_price=strategy.getUpperLimitPrice(new Integer(serviceID));
                
                goMsg_Dest(constant.MSG_RequestService, res, dest);
                negotiations.put(res.getConversation_ID(), new Conversation(((long)(getTime()*1000)), res.getConversation_ID(), null, res));
                //Conversation currentConversation = (Conversation) negotiations.get(res.getConversation_ID());
                //Msg myCurrentProposal = (Msg) currentConversation.getLastSentMessage();
                
                //Set Timer
                double now_ = getTime();
                double time_ = now_ + 0.5;
                TM_EVT stoprcptimeoutEvent = null;
                stoprcptimeoutEvent = new TM_EVT(constant.START_DEMAND, res.getConversation_ID().intValue(), time_);
                setTimeoutAt(stoprcptimeoutEvent, time_);
                
            };
        }
        else {
            //checkRestrictions false do nothing but log
            store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, "Not enough money to demand service "+serviceID);
        }
    }
    
    protected boolean checkRestrictions(int itemID) {
        //Budget has to be higher than the upper Limitprice
        if (strategy.getUpperLimitPrice(new Integer(itemID)) < money_balance) {
            return true;
        }
        else {
            return false;
        }
    }
    
    protected void adaptPriceDistribution(int itemID, int confirm) {
        String METHOD_NAME="adaptPriceDistribution()";
        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, "ItemID: " + itemID + " Contract Price: ");
        if (confirm == 1) {
            increasePriceDistribution(new Integer (itemID));
        } else {
            decreasePriceDistribution(new Integer (itemID));            
            };  
    };
    
    protected void increasePriceDistribution(Integer itemID) {
        String METHOD_NAME="increasePriceDistribution()";
        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, "MarketPrices adapted to demand: Old: "+strategy.getLowerLimitPrice(itemID)+"/"+strategy.getUpperLimitPrice(itemID)+" New: "+strategy.getLowerLimitPrice(itemID)*(1+constant.adjustprice2demand)+"/"+strategy.getUpperLimitPrice(itemID)*(1+constant.adjustprice2demand));
        strategy.setPrices(itemID, strategy.getLowerLimitPrice(itemID)*(1+constant.adjustprice2demand/100), strategy.getUpperLimitPrice(itemID)*(1+constant.adjustprice2demand/100));
    };
    
    protected void decreasePriceDistribution(Integer itemID) {
        String METHOD_NAME="decreasePriceDistribution()";
        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, "MarketPrices adapted to demand: Old: "+strategy.getLowerLimitPrice(itemID)+"/"+strategy.getUpperLimitPrice(itemID)+" New: "+strategy.getLowerLimitPrice(itemID)*(1-constant.adjustprice2demand)+"/"+strategy.getUpperLimitPrice(itemID)*(1-constant.adjustprice2demand));
        strategy.setPrices(itemID, strategy.getLowerLimitPrice(itemID)*(1-constant.adjustprice2demand/100), strategy.getUpperLimitPrice(itemID)*(1-constant.adjustprice2demand/100));
    };
    
    public void postRejectanceMethod(Msg currentMessage) {
        // PauStrategy
        if (constant.m_baseline) {
            adaptPriceDistribution(currentMessage.itemID, 0);
        } else {
            increasePriceDistribution(new Integer(currentMessage.itemID));
        };
        if ((ableToStartDemand) && (!isNegotiating())) {
            debug(" Demand " + currentMessage.request_ID + " not served");
            debug("\tGraph output - confirm\t" + currentMessage.request_ID);
            openCfPs.clear();
            treatNextDemand();
        };
    };
    
    public synchronized void interpretConfirm(Msg currentMessage) {
        //For logging we need the name of the method
        String METHOD_NAME="interpretConfirm()";
        // Check if we have closed any parallel conversation for this Item
        //         if ((!openCfPs.contains(currentMessage.request_ID)) && (currentMessage.itemID >= 2)) {
        Integer conversation_ID = currentMessage.getConversation_ID();
        if ((!openCfPs.contains(currentMessage.request_ID)) && !(constant.m_baseline)) {
            Msg replyMsg = null;
            if (isDebugEnabled()) { debug(currentMessage.itemID+" has already been served."); };
            store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, conversation_ID, currentMessage.itemID+" has already been served.");
            replyMsg = currentMessage.createReply(ownID, constant.MSG_Reject, currentMessage.switchDocumentType(), 0);
            goMsg_Dest(constant.MSG_Reject, replyMsg, currentMessage.sender_hp);
            return;
        }
        //if Client gets Service remove from openCfPs List
        if (!constant.m_baseline) {
            // INBOX-Stack
            setNegotiating(false);
            store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, currentMessage.getConversation_ID(), "SC "+ownID+" rejects");
            rejectPendingNegotiations(currentMessage.request_ID);
        } else {
            adaptPriceDistribution(currentMessage.itemID, 1);
        };
        openCfPs.remove(currentMessage.request_ID);
        Conversation currConv = (Conversation) negotiations.get(currentMessage.getConversation_ID());

        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, currentMessage.getConversation_ID(), "msg_hopcounter: " + currentMessage.hop_counter);   
       
        //give Money to SC
        //initiate money flow to SC
        store.log(CLASS_NAME, constant.log_business, METHOD_NAME, ownID, this.LOCALHP.p, currentMessage.getConversation_ID(),"Resource "+ownID+": Confirm received from "+currentMessage.sender_hp.h);
        
        Msg message=new Msg();
        message.price=currentMessage.price;
        message.bwprice=currentMessage.bwprice;
        message.hopfactorprice = currentMessage.hopfactorprice;
        message.itemID = currentMessage.itemID;

        if (constant.m_baseline == false) {
            // Ponemos el tiempo inicial de la conversacion al tiempo inicial de la peticion
            Conversation initialConversation = (Conversation) negotiations.get(currentMessage.request_ID);
            currConv.setStartTime(initialConversation.getStartTime());
            currConv.addCurrent(((long)(getTime()*1000)));
            long accessTime = currConv.getAcumulated();
            debug(" Demand " + currentMessage.request_ID + " served by serviceCopy " + currentMessage.sender_hp.h + ":" + currentMessage.sender_hp.p + " on resource " + currentMessage.resource.h +  " in " + accessTime + " ms, at price " + currentMessage.price + " in " + currentMessage.hop_counter + " hops");
            debug("\tGraph output - confirm\t" + currentMessage.request_ID + "\t" + currentMessage.sender_hp.h + "\t" + currentMessage.sender_hp.p + "\t" + currentMessage.resource.h + "\t" + accessTime + "\t" + currentMessage.price + "\t" + currentMessage.hop_counter);
            message.receiver_hp=currentMessage.sender_hp;
            negotiations.remove(currentMessage.request_ID);
            decreasePriceDistribution(new Integer(currentMessage.itemID));
        }
        else {
            currConv.addCurrent(((long)(getTime()*1000)));
            long accessTime = currConv.getAcumulated();
            debug(" Demand " + currentMessage.request_ID + " served by serviceCopy " + currentMessage.serviceprovider.h + ":" + currentMessage.serviceprovider.p + " on resource " + currentMessage.resource.h +  " in " + accessTime + " ms, at price " + currentMessage.price + " in " + currentMessage.hop_counter + " hops");
            debug("\tGraph output - confirm\t" + currentMessage.request_ID + "\t" + currentMessage.serviceprovider.h + "\t" + currentMessage.serviceprovider.p + "\t" + currentMessage.resource.h + "\t" + accessTime + "\t" + currentMessage.price + "\t" + currentMessage.hop_counter);
            message.receiver_hp=currentMessage.serviceprovider;
            message.resource = currentMessage.resource;
        }
        
        message.setConversation_ID(currentMessage.getConversation_ID());
        message.sender_hp=this.LOCALHP;
        negotiations.remove(currentMessage.getConversation_ID());
        // PauStrategy
        
        if (decreaseBudget(currentMessage.price)) {
            goMsg_Dest(constant.MSG_MoneyTransfer, message, message.receiver_hp);
        };
        
        //Store AccessTime
        store.log_access_time(new Float(((long)(getTime()*1000)) - currConv.getStartTime()).intValue());
        
        //Store Benefit
        store.log_benefit(strategy.getAveragePrice(new Integer (currentMessage.itemID)) - currentMessage.price);
        constant.changeSWF(strategy.getAveragePrice(new Integer (currentMessage.itemID)) - currentMessage.price);
        debug("Client Budget change: " + currentMessage.price);
        if (!constant.m_baseline) {
            learn((strategy.getAveragePrice(new Integer (currentMessage.itemID)) - currentMessage.price), new Integer(currentMessage.itemID));
            store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, currentMessage.getConversation_ID(), "Client is learning: " + (strategy.getAveragePrice(new Integer (currentMessage.itemID)) - currentMessage.price) + " factorID: " +  currentMessage.itemID);   
        };
        treatNextDemand();
        
    }
    
    public void interpretMoneyTransfer(Msg currentMessage) {
        //Nothing to be done. If Client gets an income, this method should be implemented
    };
    
    public void learn(double gain, Integer factorID) {
        if (! constant.learning)
            return;
        
        String METHOD_NAME="learn";
        //Learn something about that deal
        float profit=(float) gain;
        strategy.getLearningModule().addPrivateInformation(new Float(profit), factorID);
        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, "LEARNING Info: ILearning.PROPAGATE: " + ILearning.PROPAGATE + " getRecommendedLearningAction: " + strategy.getLearningModule().getRecommendedLearningAction() + "=?" + ILearning.PROPAGATE);
        
        if ((ILearning.PROPAGATE & strategy.getLearningModule().getRecommendedLearningAction()) == ILearning.PROPAGATE) {
            //prepare broadcastmessage
            Integer Conversation_ID=new Integer(constant.conversation_counter++);
            for (int i = 0; i < knownResourcesNum; i++) {
                Msg plumage_message = new Msg();
                Hp dest = new Hp(knownResources[i], 101);
                plumage_message.broadcast=true;
                plumage_message.setConversation_ID(Conversation_ID);
                plumage_message.receiver_hp=dest;
                plumage_message.sender_hp=this.LOCALHP;
                plumage_message.hop_counter=0;
                Object plumage_object=accept_plumage.get(0);
                Integer plumage_Integer= (Integer) plumage_object;
                plumage_message.itemID=plumage_Integer.intValue();
                plumage_message.setPlumage((Plumage) strategy.getLearningModule().createFitnessInformation(strategy.getLearningModule().getAverageProfit()));
                     
                goMsg_Dest(constant.MSG_Plumage, plumage_message, dest);
                store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, Conversation_ID, "Plumage sent to " + dest.h);
               };
            }
    };
    
    public void interpret_Plumage(Msg message) {
        String METHOD_NAME="interpret_Plumage()";
        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, message.getConversation_ID(), "Plumage received  itemID= " + message.itemID + " accept_plumage= " + accept_plumage);
            
        if (accept_plumage.contains(new Integer(message.itemID))) {
            Plumage courterPlumage = (Plumage) message.getPlumage();
            strategy.getLearningModule().addPublicInformation(courterPlumage);
            store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, message.getConversation_ID(), "Genotype now: " + strategy.getMyGenotype() + "Plumage: " + courterPlumage.getSenderGenes());
            
            if (((ILearning.ADAPT & strategy.getLearningModule().getRecommendedLearningAction()) == ILearning.ADAPT) || (1 == 1)) {
                strategy.setMyGenotype((Genotype) strategy.getLearningModule().learn(strategy.getMyGenotype()));
                store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, message.getConversation_ID(), "Genotype adapted to: " + strategy.getMyGenotype());
            };
        };
    };
    
    public void startDemand(String filename) {
        readDemand(filename);
        treatNextDemand();
    }
    
    public void treatNextDemand() {
        if (pendingDemands.isEmpty())
            return;
        
        Float currTime = (Float) pendingDemands.firstKey();
        Integer currItemID = (Integer) pendingDemands.get(currTime);
        pendingDemands.remove(currTime);

        
        //Set Timer
        double now_ = getTime();
        double time_ = currTime.floatValue()/1000;
        if (now_ > time_) {
            service_Demand(currItemID.intValue());
        }
        else {
            TM_EVT stoprcptimeoutEvent = null;
            stoprcptimeoutEvent = new TM_EVT(constant.NEXT_DEMAND, currItemID.intValue(), time_);
            setTimeoutAt(stoprcptimeoutEvent, time_);
        }
    };
    
}
