package catnet.data;

import catnet.util.Hp;
import catnet.learning.stdea.Plumage;

/**
 *  Description of the Class
 *
 *@author     eymann
 *@created    5. August 2002
 */
public class Msg {
    /**
     *  Sender, Receiver, Conversation
     */
    public Hp receiver_hp;
    /**
     *  Description of the Field
     */
    public Hp sender_hp;
    /**
     *  Description of the Field
     */
    public int senderID;
    /**
     *  Description of the Field
     */
    private Integer conversation_ID;

    private Plumage msg_plumage;
    
    public Integer request_ID;
    
    /**
     *  broadcast is set true by resource if it sends to known resources
     */
    public boolean broadcast=false; 

    //from msgProposal
    /**
     *  describing parameters for the proposal
     */
    public int itemID;
    /**
     *  Description of the Field
     */
    public int amount;
    /**
     *  Description of the Field
     */
    public double price, bwprice, ASK_price, BID_price, hopfactorprice;

    /**
     *  what to do with the message
     */
    public int verdict, total_requests, unsat_requests, sat_requests, SC_itemID, numSCs;
    /**
     *  Description of the Field
     */
    public int DocumentType;

    //is it an ASK or BID

    //from msgApproveProvideService
    /**
     *  Description of the Field
     */
    public boolean doInvokeService;
    /**
     *  Description of the Field
     */
    private Hp requestingClient, requestingResource, requestingServiceCopy;

    //from msgConfirm
    /**
     *  Description of the Field
     */
    public Hp resource, serviceprovider;
    
    public boolean SCisON = true;
    
    public Msg() {};

    /**
     *  Description of the Method
     *
     *@param  hp  Description of the Parameter
     *@param  v   Description of the Parameter
     *@param  i   Description of the Parameter
     *@param  a   Description of the Parameter
     *@param  m   Description of the Parameter
     *@return     Description of the Return Value
     */
    public Msg(Msg m) {
        receiver_hp = m.receiver_hp;
        verdict = m.verdict;
        itemID = m.itemID;
        price = m.price;
        sender_hp=m.sender_hp;
        total_requests=m.total_requests;
        unsat_requests=m.total_requests;
        requestingClient=m.requestingClient;
        requestingServiceCopy = m.requestingServiceCopy;
        SC_itemID=m.SC_itemID;
        request_ID=m.request_ID;
        msg_plumage=m.msg_plumage;
        ASK_price=m.ASK_price;
        BID_price=m.BID_price;
        DocumentType=m.DocumentType;
        hopfactorprice = 0;
    }
    public Msg(Hp hp, int v, int i, int a, int m) {
        receiver_hp = hp;
        verdict = v;
        itemID = i;
        amount = a;
        price = m;
        hopfactorprice = 0;
    }


    //from msgInform
    /**
     *  Description of the Field
     */
    public int n;
    /**
     *  Description of the Field
     */
    public Hp[] hp;

    //from msgProvideService
    /**
     *  Description of the Field
     */
    public boolean doPayDues;

    //from msgResourceLocation
    /**
     *  Description of the Field
     */
   public Hp locationId;

   public int hop_counter = 0;
    
   public Msg createReply() {
        Msg rep = new Msg();
        rep.itemID = this.itemID;
        rep.amount = this.amount;
        rep.verdict = this.verdict;
        rep.price = this.price;
        rep.conversation_ID = this.conversation_ID;

        Hp i = this.receiver_hp;
        rep.receiver_hp = this.sender_hp;
        rep.DocumentType = switchDocumentType();
        rep.total_requests=this.total_requests;
        rep.unsat_requests=this.unsat_requests;
        rep.SC_itemID=this.SC_itemID;
        rep.request_ID=this.request_ID;
        rep.ASK_price=this.ASK_price;
        rep.BID_price=this.BID_price;
        return rep;
}

    /**
     *  Description of the Method
     *
     *@param  senderID      Description of the Parameter
     *@param  verdict       Description of the Parameter
     *@param  DocumentType  Description of the Parameter
     *@param  price         Description of the Parameter
     *@return               Description of the Return Value
     */

    public synchronized Msg createReply(int s, int v, int d, double p) {
        Msg rep = new Msg();
        rep.itemID = this.itemID;
        rep.senderID = s;
        rep.amount = this.amount;
        rep.verdict = v;
        rep.DocumentType = d;
        rep.price = p;
        rep.conversation_ID = this.conversation_ID;
        if (constant.debuglog) System.out.println("Msg: convID = "+rep.conversation_ID+" "+this.sender_hp.h);

        Hp i = this.receiver_hp;
        rep.receiver_hp = this.sender_hp;
        rep.sender_hp = i;
        rep.SC_itemID=this.SC_itemID;
        rep.total_requests=this.total_requests;
        rep.unsat_requests=this.unsat_requests;
        rep.request_ID=this.request_ID;
        
        rep.requestingClient = this.requestingClient;
        rep.requestingResource = this.requestingResource;
        return rep;
    }


    public synchronized int switchDocumentType() {
    return (DocumentType == constant.BID ? constant.ASK : constant.BID);
}
  public Integer getConversation_ID() {
    return this.conversation_ID;
  }
  public synchronized void setConversation_ID(Integer conversation_ID) {
    this.conversation_ID = conversation_ID;
  }

  /** Getter for property hpClient.
   * @return Value of property hpClient.
   */
  public Hp getRequestingClient() {
      return this.requestingClient;
  }
  
  /** Getter for property hpCResource.
   * @return Value of property hpCResource.
   */
  public Hp getRequestingResource() {
      return this.requestingResource;
  }
  
  /** Setter for property hpClient.
   * @param hpClient New value of property hpClient.
   */
  public void setRequestingClient(Hp hc) {
  this.requestingClient = hc;
  }

    public void setPlumage(Plumage plum) {
      this.msg_plumage = plum;
  };
  
  public Plumage getPlumage() {
      return this.msg_plumage;
  };

  /** Setter for property hpResource.
   * @param hpResource New value of property hpResource.
   */
  public void setRequestingResource(Hp hr) {
      this.requestingResource = hr;}

  public Hp getRequestingServiceCopy() {
      return requestingServiceCopy;
  }

  public void setRequestingServiceCopy(Hp hsc) {
      this.requestingServiceCopy = hsc;
  }
}
