package catnet.learning.stdea;

import java.util.*;

/**
 *  basic binary gene (ala typical GAs). In principle directly transcribed from
 *  the Egglets.
 *
 *@author     RES, Immi
 *@created    10. Oktober 2001
 */
public class BooleanGene extends Gene {
    /**
     *  set at random value
     *
     *@param  rand  Description of the Parameter
     */
    public final void randomize(Random rand) {
        geneValue = new Boolean((float) 0.5 > rand.nextFloat());
    }


    /**
     *  There is only one opportunity to mutate booleans - flip the value, which
     *  is what happens here.
     *
     *@param  rand  is not used.
     */
    public final void mutate(Random rand) {
        geneValue = new Boolean(((Boolean) geneValue).booleanValue() ^ true);
    }
}
