package catnet.negotiation;

import catnet.data.Msg;
import java.util.LinkedList;
import java.util.HashSet;

/*
 *@author     Dr. Torsten Eymann, Michael Reinicke
 *@created    26. Juni 2002
 *@version    1.0
 */

public class Conversation {

    /**
     *  Description of the Field
     */
    private Msg lastSentMessage = null;

    /**
     *  Description of the Field
     */
    private Msg lastReceivedMessage = null;

    /**
     *  Description of the Field
     */
    private int counter = 0;
    /**
     *  Description of the Field
     */
    private Integer conversationID;
    /**
     *  Description of the Field
     */
    private long startTime;
    private long acuTime = 0;

    private double bandwidth_price;
    
    /** Holds value of property correspondingConversation. */
    private Integer correspondingConversation;
    
    public LinkedList otherResources;
    
    public HashSet correspondingASKs;
    
    protected int distanceGuess = 0;
    
    /**
     *  Constructor for the Conversation object
     *
     *@param  id  Description of the Parameter
     *@param  m   Description of the Parameter
     *@param  t   Description of the Parameter
     */
 public Conversation(long t, Integer id, Msg m) {
        setStartTime(t);
        this.conversationID = id;
        this.lastSentMessage = m;
        this.counter++;
        this.otherResources = new LinkedList();
        this.correspondingASKs = new HashSet();
    }

   /**
     *  Constructor for the Conversation object
     *
     *@param  t   Description of the Parameter
     *@param  id  Description of the Parameter
     *@param  m   Description of the Parameter
     *@param  r   Description of the Parameter
     */
    public Conversation(long t, Integer id, Msg m, Msg r) {
        this.conversationID = id;
        this.lastReceivedMessage = m;
        this.lastSentMessage = r;
        this.counter++;
        setStartTime(t);
        this.otherResources = new LinkedList();
        this.correspondingASKs = new HashSet();
    }

    public Conversation(Integer id, Msg m) {
        this.lastSentMessage=m;
        this.conversationID=id;
        this.otherResources = new LinkedList();
        this.correspondingASKs = new HashSet();
    }    

    public Conversation(Integer i) {
        this.conversationID=i;
        this.otherResources = new LinkedList();
        this.correspondingASKs = new HashSet();
    }
    
    public Conversation(long t, Integer id, Msg m, Msg r, double bandwidth_price, Integer ConvID) {
        this.conversationID = id;
        this.lastReceivedMessage = m;
        this.lastSentMessage = r;
        this.counter++;
        setStartTime(t);
        this.bandwidth_price=bandwidth_price;
        this.correspondingConversation=ConvID;
        this.otherResources = new LinkedList();
        this.correspondingASKs = new HashSet();
    }
    
    /**
     *  Description of the Method
     */
    public void increaseCounter() {
        this.counter++;
    }


    /**
     *  Gets the counter attribute of the Conversation object
     *
     *@return    The counter value
     */
    public int getCounter() {
        return counter;
    }


    /**
     *  Gets the lastReceivedMessage attribute of the Conversation object
     *
     *@return    The lastReceivedMessage value
     */
    public Msg getLastReceivedMessage() {
        return lastReceivedMessage;
    }


    /**
     *  Gets the lastSentMessage attribute of the Conversation object
     *
     *@return    The lastSentMessage value
     */
    public Msg getLastSentMessage() {
        return lastSentMessage;
    }


    /**
     *  Sets the lastSentMessage attribute of the Conversation object
     *
     *@param  lastSentMessage  The new lastSentMessage value
     */
    public void setLastSentMessage(Msg lastSentMessage) {
        this.lastSentMessage = lastSentMessage;
    }


    /**
     *  Sets the lastReceivedMessage attribute of the Conversation object
     *
     *@param  lastReceivedMessage  The new lastReceivedMessage value
     */
    public void setLastReceivedMessage(Msg lastReceivedMessage) {
        this.lastReceivedMessage = lastReceivedMessage;
    }


    /**
     *  Sets the conversationID attribute of the Conversation object
     *
     *@param  conversationID  The new conversationID value
     */
    public void setConversationID(Integer conversationID) {
        this.conversationID = conversationID;
    }


    /**
     *  Gets the conversationID attribute of the Conversation object from the
     *  getReplyID() method of Lars' CommunicationTemplate
     *
     *@return    The conversationID value
     */
    public Integer getConversationID() {
        return conversationID;
    }


    /**
     *  Gets the startTime attribute of the Conversation object
     *
     *@return    The startTime value
     */
    public long getStartTime() {
        return startTime;
    }

    public void setStartTime(long in_startTime) {
        startTime = in_startTime;
    }

    public void addCurrent(long now) {
        acuTime += now - startTime;
        setStartTime(0);
    }

    public long getAcumulated() {
        return acuTime;
    }
    
    
    /** Getter for property bandwidth_price.
     * @return Value of property bandwidth_price.
     */
    public double getBandwidth_price() {
        return this.bandwidth_price;
    }
    
    /** Setter for property bandwidth_price.
     * @param bandwidth_price New value of property bandwidth_price.
     */
    public void setBandwidth_price(double bandwidth_price) {
        this.bandwidth_price = bandwidth_price;
    }
    
    /** Getter for property correspondingConversation.
     * @return Value of property correspondingConversation.
     */
    public Integer getCorrespondingConversation() {
        return this.correspondingConversation;
    }
    
    /** Setter for property correspondingConversation.
     * @param correspondingConversation New value of property correspondingConversation.
     */
    public void setCorrespondingConversation(Integer correspondingConversation) {
        this.correspondingConversation = correspondingConversation;
    }
    
    public void setDistance(int hops) {
        distanceGuess = hops;
    }
    
    public int getDistance() {
        return distanceGuess;
    }
}
