package catnet.negotiation;

import catnet.negotiation.*;

/**
 *  berschrift: B2B-OS Beschreibung: Copyright: Copyright (c) 2001
 *  Organisation: IIG Telematik, Albert-Ludwigs-Universitaet Freiburg
 *
 *@author     Dr. Torsten Eymann
 *@created    24. Mrz 2002
 *@version    1.0
 */

public class OrderbookItem implements Comparable {

    /**
     *  Description of the Field
     */
    private Proposal proposal;
    /**
     *  Description of the Field
     */
    private double price;
  private String owner;


    /**
     *  Constructor for the OrderBookItem object
     *
     *@param  p  Description of the Parameter
     */
    public OrderbookItem(Proposal p) {
        price = p.getUnitPrice();
        owner = p.getOwner();
        proposal = p;
    }


    /**
     *  Description of the Method
     *
     *@param  obi  Description of the Parameter
     *@return      Description of the Return Value
     */
    public boolean equals(OrderbookItem obi) {
        return (obi.getPrice() == this.price);
    }


    /**
     *  Description of the Method
     *
     *@param  o  Description of the Parameter
     *@return    Description of the Return Value
     */
    public int compareTo(Object o) {
        if (o instanceof OrderbookItem) {
            OrderbookItem obi = (OrderbookItem) o;
            int r = 0;
            if (!this.equals(obi)) {
                double diff = this.price - obi.getPrice();
                r = (diff > 0 ? 1 : -1);
            }
            return r;
        } else {
            return 0;
        }
    }


    /**
     *  Gets the proposal attribute of the OrderbookItem object
     *
     *@return    The proposal value
     */
    public Proposal getProposal() {
        return proposal;
    }


    /**
     *  Gets the price attribute of the OrderbookItem object
     *
     *@return    The price value
     */
    public double getPrice() {
        return price;
    }
  public void setOwner(String owner) {
    this.owner = owner;
  }
  public String getOwner() {
    return owner;
  }
}
