package catnet.negotiation;

//import catnet.util.Distribution;
import java.util.Date;
import catnet.accounting.Factor;

/**
 * berschrift:   Catnet
 * Beschreibung:  Catallactic Network Simulator for Java
 * Copyright:     Copyright (c) 2001
 * Organisation:  IIG Telematik, Uni Freiburg
 * @author Torsten Eymann
 * @version 1.0
 */

public class ProposalLineItem extends Factor {

    /**
     *  Description of the Field
     */
    private int productQuantity = 0;
    /**
     *  The single negotiation attribute for commodities.
     */
    private double unitPrice = 0;

    /**
     *  Description of the Field
     */
    private String owner = "";
    /**
     *  Description of the Field
     */
    private String negotiationID;


    /**
     *  Constructor for the ProposalLineItem object
     *
     *@param  q   Description of the Parameter
     *@param  p   Description of the Parameter
     *@param  id  Description of the Parameter
     */
    public ProposalLineItem(Integer id, int q, double p) {
        this.setProductIdentification(id);
        this.productQuantity = q;
        this.unitPrice = p;
    }


    /**
     *  Gets the owner attribute of the ProposalLineItem object
     *
     *@return    The owner value
     */
    public String getOwner() {
        return owner;
    }


    /**
     *  Sets the owner attribute of the ProposalLineItem object
     *
     *@param  owner  The new owner value
     */
    public void setOwner(String owner) {
        this.owner = owner;
    }


    /**
     *  Sets the productQuantity attribute of the ProposalLineItem object
     *
     *@param  productQuantity  The new productQuantity value
     */
    public void setProductQuantity(int productQuantity) {
        this.productQuantity = productQuantity;
    }


    /**
     *  Gets the productQuantity attribute of the ProposalLineItem object
     *
     *@return    The productQuantity value
     */
    public int getProductQuantity() {
        return productQuantity;
    }


    /**
     *  Gets the unitPrice attribute of the ProposalLineItem object
     *
     *@return    The unitPrice value
     */
    public double getUnitPrice() {
        return unitPrice;
    }


    /**
     *  Sets the unitPrice attribute of the ProposalLineItem object
     *
     *@param  unitPrice  The new unitPrice value
     */
    public void setUnitPrice(double unitPrice) {
        this.unitPrice = unitPrice;
    }


    /**
     *  Sets the negotiationID attribute of the ProposalLineItem object
     *
     *@param  negotiationID  The new negotiationID value
     */
    public void setNegotiationID(String negotiationID) {
        this.negotiationID = negotiationID;
    }


    /**
     *  Gets the negotiationID attribute of the ProposalLineItem object
     *
     *@return    The negotiationID value
     */
    public String getNegotiationID() {
        return negotiationID;
    }

}
