package catnet.resource;

import java.util.Map;
import java.util.HashMap;
import java.util.Hashtable;
import java.lang.Integer;
import java.lang.Long;
import java.lang.*;
import java.util.Enumeration;
import java.util.Set;
import java.util.Vector;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Collection;
import java.util.LinkedList;
import catnet.negotiation.Conversation;
import catnet.agent.*;
import catnet.util.Hp;
import catnet.data.Msg;
import catnet.data.constant;
import catnet.data.Debug;
import catnet.log.store;
import catnet.data.resourceData;
import catnet.util.TM_EVT;
import catnet.learning.stdea.Genotype;
import catnet.learning.ILearning;
import catnet.learning.stdea.Plumage;
/**
 *  Description of the Class
 *
 *@author     eymann
 *@created    5. August 2002
 */
public class Resource extends Agent_Source {
    
    /**
     *  Description of the Field
     */
    public Hashtable knownServiceCopies = new Hashtable(MAX);
    public HashSet knownClients = new HashSet(MAX);
    int portValues = 4096;
    /**
     *  Description of the Field
     */
    String CLASS_NAME="Resource";

    protected LinkedList currentServingSC = new LinkedList();
    public LinkedList currentRecovering = new LinkedList();
    protected LinkedList acumulatedRecovers = new LinkedList();
    
    /**
     *  Description of the Field
     */
//    int numberOfStorageResourceUnits = MAX;
    /**
     *  Description of the Field
     */
//    int numberOfBWResourceUnits = MAX;
    /**
     *  Description of the Field
     */
    int StorageResourceUnits = MAX;
    /**
     *  Description of the Field
     */
//    int BWResourceUnits = MAX;
    
    /**
     * Counts number of total requests per item
     */
    protected HashMap total_requests=new HashMap();
    
    /**
     * Counts number of not unsatisfied requests per item
     **/
    protected HashMap unsatisfied_requests=new HashMap();
    protected HashMap satisfied_requests=new HashMap();
    
    /*
     *  Map hold info about Storagereserved per ServiceCopies, key=SCId.h, Element=resourceData;
     */
    /**
     *  Description of the Field
     */
    private Map StorageReservedServiceId = new HashMap();
    
    /*
     *  Map hold info about BWReserved per ServiceCopies, key=SCId.h, Element=resourceData;
     */
    /**
     *  Description of the Field
     */
    private Map BWReservedServiceId = new HashMap();
    
    public Vector resourceKnownResources = new Vector();
    
    private Map SCBWReservedTransactionId = new HashMap();
    
    //private int free_bandwidth=constant.free_bandwidth;
    
    public int SCBWUnits = constant.free_bandwidth;
    
    private HashSet usedPorts;
    
    //private HashMap knownResources=new Hashtable(MAX);

    /**
     *  Constructor for the Resource object
     */
    public Resource() {
        super();
        
        //Set tradeable itemIDs
        tradeable.addElement(new Integer(0));
        tradeable.addElement(new Integer(1));
        
        //Set itemIDs to accept plumage
        accept_plumage.addElement(new Integer(0));
        accept_plumage.addElement(new Integer(1));
        
        usedPorts = new HashSet();
    }
    
    /**
     *  Sets the resourceknownResources attribute of the Resource object
     *
     *@param  resource_ID    The knownResourceID value
     */
    
    public void setknownResources(int resource_ID) {
        resourceKnownResources.addElement(new Long(resource_ID));
    }
    
    //Only needed for Script
    public void listknownResources(int resource_ID) {
        int i,n;
        n=resourceKnownResources.size();
        for (i=0;i<n;i++) {
            Long elem = (Long)resourceKnownResources.get(i);
            if (isDebugEnabled()) { debug("resourceID "+resource_ID+" knows resource "+elem.longValue()); };
        }
    }
    
    /**
     *  Sets the knownServiceCopies attribute of the Client object
     *
     *@param  n    The new knownServiceCopies value
     *@param  res  The new knownServiceCopies value
     */
    public void setKnownServiceCopies(int n, long[] res, int[] service_ID) {
        int[] ports = new int[n];
        for (int i=0; i<n;i++)
            ports[i] = 101;
        setKnownServiceCopies(n, res, ports, service_ID);
    }
    
    public void addKnownServiceCopy(long res, int port, int sID) {
        long[] node = new long[1];
        int[] service_ID = new int[1];
        int[] ports = new int[1];
        ports[0] = port;
        node[0] = res;
        service_ID[0] = sID;
        setKnownServiceCopies(1, node, ports, service_ID);
    }
    
    /**
     *  Sets the knownServiceCopies attribute of the Client object
     *
     *@param  n    The new knownServiceCopies value
     *@param  res  The new knownServiceCopies value
     */
    public void setKnownServiceCopies(int n, long[] res, int[] ports, int[] service_ID) {
        int i;
        for (i = 0; i < n; i++) {
            // suponiendo que estan en el mismo nodo
            usedPorts.add(new Integer(ports[i]));
            knownServiceCopies.put(new Long((res[i]<<constant.portBits) + ports[i]), new Long(service_ID[i])); // Pau 2002-10-24
            ///            knownServiceCopies.put(new Long(res[i]), new Long(service_ID[i]));
            //Inform Service about her resource
            Msg inform_msg=new Msg();
            inform_msg.sender_hp=new Hp(LOCALHP);
            inform_msg.receiver_hp=new Hp(res[i], ports[i]);
            //            inform_msg.receiver_hp=new Hp(res[i], 101);
            inform_msg.resource=new Hp(LOCALHP);
            inform_msg.setConversation_ID(new Integer(0));
            inform_msg.price=strategy.getAveragePrice(new Integer(1));
            if (isDebugEnabled()) { debug("Sending Inform Message to ServiceCopy"); };
            
            goMsg_Dest(constant.MSG_informResourceHost, inform_msg, inform_msg.receiver_hp);
        }
    }

    public void removeKnownServiceCopy(Hp currSC) {
        long icurrSC = (currSC.h<<constant.portBits) + currSC.p;
        knownServiceCopies.remove(new Integer(new Long(icurrSC).intValue()));
        usedPorts.remove(new Integer(currSC.p));   
    }
    
    public int getFreePort() {
        int freePort = 104;
        while (usedPorts.contains(new Integer(freePort))) {
            freePort++;
        }
        return freePort;
    }
    
    public void addKnownClient(long h, int p) {
            knownClients.add(new Long((h<<constant.portBits) + p));
    }

    
    //********************************************************
    // RESOURCE METHODS
    // *******************************************************
    
    public void interpretRequestService(Msg msg){
        String METHOD_NAME="interpretRequestService";
        //This just counts the number of incoming requests for an itemID
        if (total_requests.containsKey(new Integer(msg.itemID))) {
            Integer requests=(Integer) total_requests.get(new Integer(msg.itemID));
            int request_int=requests.intValue();
            total_requests.put(new Integer(msg.itemID), new Integer(++request_int));
        } else {
            total_requests.put(new Integer(msg.itemID), new Integer(1));
        }
        
        //1. check if service copy is on own resource
        /**
         * msg.hop_counter++;
         * list = checkServiceCopies(itemID)
         * for i = 1 to length(list) do
         * send(request) to SC
         *
         */
        
        //Scan itemID at SCs
        Enumeration the_keys=knownServiceCopies.keys();
        while(the_keys.hasMoreElements()) {
            Long url= (Long) the_keys.nextElement();
            Long item_id= (Long) knownServiceCopies.get(url);
            Integer dport = new Integer(url.intValue()%portValues);
            url = new Long(url.longValue() >> constant.portBits);

            if (isDebugEnabled()) { debug("scan services at SC "+url.longValue()+ "looking for " + msg.itemID); };
            
            if ((url.longValue() != msg.getRequestingClient().h) && (item_id.equals(new Long(msg.itemID)))) {
                if (isDebugEnabled()) { debug("Resource "+ownID+": Service "+msg.itemID+" found at SC "+url+":"+dport); };

                Msg msg_forward=new Msg(msg);
                
                // In baseline it is similar to an accept so we reserve the bandwith
                if (constant.m_baseline)
                {
                    decrease_bandwidth();
                    msg_forward.BID_price=msg.BID_price;
                }

                //Forward message to SC
                
                msg_forward.hop_counter=msg.hop_counter;
                msg_forward.broadcast=false;
                msg_forward.setConversation_ID(msg.getConversation_ID());
                msg_forward.receiver_hp=new Hp(url.longValue(), dport.intValue());
                msg_forward.sender_hp=new Hp(LOCALHP);
                msg_forward.bwprice = strategy.getAveragePrice(new Integer(0));
                msg_forward.setRequestingClient(msg.getRequestingClient());
                store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, msg.getConversation_ID(), "Ressource: "+ownID+" Service "+msg.itemID+" found at SC "+url+":"+dport+". Sending request to SC "+url);
                goMsg_Dest(constant.MSG_RequestService, msg_forward, msg_forward.receiver_hp);
            };
        }
        //else do nothing;
    }
    
    public void forwardPlumage(Msg msg){
        forwardPlumageToServiceCopies(msg);
        forwardPlumageToClients(msg);
    }
    
    public void forwardPlumageToServiceCopies(Msg msg){
        String METHOD_NAME="forwardPlumageToServiceCopies";
        
        Enumeration the_keys=knownServiceCopies.keys();
        while(the_keys.hasMoreElements()) {
            Long url= (Long) the_keys.nextElement();
            Long item_id= (Long) knownServiceCopies.get(url);
            Integer dport = new Integer(url.intValue()%portValues);
            url = new Long(url.longValue() >> constant.portBits);
            
            Msg msg_forward=new Msg(msg);
            msg_forward.hop_counter=msg.hop_counter;
            msg_forward.broadcast=false;
            msg_forward.setConversation_ID(msg.getConversation_ID());
            msg_forward.receiver_hp=new Hp(url.longValue(), dport.intValue());
            msg_forward.sender_hp=new Hp(LOCALHP);
            goMsg_Dest(constant.MSG_Plumage, msg_forward, msg_forward.receiver_hp);
        }
    }
    
    
    public void forwardPlumageToClients(Msg msg){
        String METHOD_NAME="forwardPlumageToClients";
        Iterator clientIt = knownClients.iterator();
        while(clientIt.hasNext()) {
            Long url= (Long) clientIt.next();
            Integer dport = new Integer(url.intValue()%portValues);
            url = new Long(url.longValue() >> constant.portBits);
            
            Msg msg_forward=new Msg(msg);
            
            //Forward message to Client
            msg_forward.hop_counter=msg.hop_counter;
            msg_forward.broadcast=false;
            msg_forward.setConversation_ID(msg.getConversation_ID());
            msg_forward.receiver_hp=new Hp(url.longValue(), dport.intValue());
            msg_forward.sender_hp=new Hp(LOCALHP);
            goMsg_Dest(constant.MSG_Plumage, msg_forward, msg_forward.receiver_hp);
        }
    }
    
    
    /**
     *  Description of the Method
     *
     *@param  msg  Description of the Parameter
     */
    public void do_ServiceCopy(Msg msg) {
        Msg res = new Msg(msg);
        
        res.receiver_hp = LOCALHP;
        
        debug("id=" + res.itemID + ", amount=" + res.amount + ", money=" + res.price + ", verdict=" + res.verdict);
        //Debug.say(" doAccept_ServiceCopy ", 0, "hpClient.h= " + res.hpClient.h + " hpClient.p= " + res.hpClient.p);
        
        if (msg.verdict == constant.MSG_Accept) {
            
            if (StorageResourceUnits - res.amount >= 0) {
                Long mapkey = new Long(res.itemID);
                resourceData StorageAlloc = (resourceData) StorageReservedServiceId.get(mapkey);
                StorageAlloc.status = 2;
                //CONFIRMED
                BWReservedServiceId.put(mapkey, StorageAlloc);
                StorageResourceUnits -= res.amount;
                // count on freed resources
                res.verdict = constant.MSG_Accept;
            } else {
                res.verdict = constant.MSG_Reject;
            }
            
        } else if (msg.verdict == constant.MSG_Reject) {
            
            //if (STorageReservedServiceId[res.serviceId].status == 1/*OFFERRED*/) {
            //  STorageReservedServiceId[res.serviceId].status = 0;//FREE
            
            // Forget promise of future use (service)
            //resourceUnits += ServiceCopies[res.serviceId].amount; // count on freed resources
        } else {
            // ERROR: not offered first!, forget ...
        }
        
        debug("resourceUnits left in resource:" + res.receiver_hp.h + " : " + StorageResourceUnits + ", res.verdict: " + res.verdict);
        goMsg_Dest(constant.MSG_Confirm, res, msg.receiver_hp);
    }
    
    
    /**
     *  Description of the Method
     *
     *@param  msg  Description of the Parameter
     *@return      Description of the Return Value
     */
    public int doAllocateStorage(Msg msg) {
        Msg res = new Msg(msg);
        
        // debug("Resource doStoragellocation: svcId: " + res.itemID + ", client: " + msg.itemID + ", amount: " + msg.amount + ", price: " + msg.offered_price + "\n");
        
        //
        // if enough Storage: to be checked, (syncronized function?!)
        //
        resourceData StorageAlloc = new resourceData();
        StorageAlloc.status = 1;
        StorageAlloc.price = res.price;
        StorageAlloc.amount = res.amount;
        StorageAlloc.itemID = res.itemID;
        StorageAlloc.hp = msg.receiver_hp;
        Long mapkey = new Long(msg.itemID);
        StorageReservedServiceId.put(mapkey, StorageAlloc);
        return constant.ALLOCATIONOK;
        // else
        // return constant.ALLOCATIONOK;
    }

    protected void adaptPriceDistribution(int itemID, int confirm) {
        String METHOD_NAME="adaptPriceDistribution()";
        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, "ItemID: " + itemID + " Contract Price: ");        
        if (confirm == 1) {
            increasePriceDistribution(new Integer (itemID));
        } else {
            decreasePriceDistribution(new Integer (itemID));            
            };  
    };
    
    protected void increasePriceDistribution(Integer itemID) {
        String METHOD_NAME="increasePriceDistribution()";
        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, "MarketPrices adapted to demand: Old: "+strategy.getLowerLimitPrice(itemID)+"/"+strategy.getUpperLimitPrice(itemID)+" New: "+strategy.getLowerLimitPrice(itemID)*(1+constant.adjustprice2demand)+"/"+strategy.getUpperLimitPrice(itemID)*(1+constant.adjustprice2demand));
        strategy.setPrices(itemID, strategy.getLowerLimitPrice(itemID)*(1+constant.adjustprice2demand/100), strategy.getUpperLimitPrice(itemID)*(1+constant.adjustprice2demand/100));
    };
    
    protected void decreasePriceDistribution(Integer itemID) {
        String METHOD_NAME="decreasePriceDistribution()";
        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, "MarketPrices adapted to demand: Old: "+strategy.getLowerLimitPrice(itemID)+"/"+strategy.getUpperLimitPrice(itemID)+" New: "+strategy.getLowerLimitPrice(itemID)*(1-constant.adjustprice2demand)+"/"+strategy.getUpperLimitPrice(itemID)*(1-constant.adjustprice2demand));
        strategy.setPrices(itemID, strategy.getLowerLimitPrice(itemID)*(1-constant.adjustprice2demand/100), strategy.getUpperLimitPrice(itemID)*(1-constant.adjustprice2demand/100));
    };
    
    protected void postRejectanceMethod(Msg msg){
        //if this was a negotiation about storage increase unsatisfied_counter
        String METHOD_NAME="postRejectanceMethod";
        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, "Postrejectance-Method of Resource gets a price of " + msg.bwprice + " from: " + msg.sender_hp.h + ":" + msg.sender_hp.p);
        
        if (msg.itemID == -1) {
            if (constant.m_baseline) {
                increase_bandwidth();
            }
            return;
        }
        
        if (msg.itemID != 0) {
            if (unsatisfied_requests.containsKey(new Integer(msg.itemID))) {
                Integer requests=(Integer) unsatisfied_requests.get(new Integer(msg.itemID));
                int request_int=requests.intValue();
                unsatisfied_requests.put(new Integer(msg.itemID), new Integer(++request_int));
            } else {
                unsatisfied_requests.put(new Integer(msg.itemID), new Integer(1));
            }
        }
        else {
            Conversation currentConversation = (Conversation) negotiations.get(msg.getConversation_ID());
            // Si es baseline tenemos que liberar el ancho de banda
            if (constant.m_baseline) {
                increase_bandwidth();
                adaptPriceDistribution(msg.itemID, 0);
            }
            // Si es un reject despues de un accept
            
            else {
                if (((currentConversation.getLastSentMessage() != null) && (currentConversation.getLastSentMessage().verdict == constant.MSG_Accept)) ||
                ((currentConversation.getLastReceivedMessage() != null) && (currentConversation.getLastReceivedMessage().verdict == constant.MSG_Accept))) {
                    increase_bandwidth();
                    negotiations.remove(msg.getConversation_ID());
                }
                else {
                    if (! constant.m_baseline) {
                        negotiations.remove(msg.getConversation_ID());
                        decreasePriceDistribution(new Integer(msg.itemID));
                    }
                }
            }
        }
    }
    
    /**  Description of the Method
     *
     * @return    Description of the Return Value
     */
    protected boolean checkRestrictions(int itemID) {
        if (SCBWUnits >= 2) {
            return true;
        }
        else {
            
            return false;
        }
    }
    
    protected void setKnownResources() {};
    
    protected void decrease_bandwidth() {
        String METHOD_NAME = "decrease_bandwidth()";
        if (constant.debuglog) debug("agent decreaseBW");
        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID,  this.LOCALHP.p, "BW decreased to " + (this.SCBWUnits-2));
        this.SCBWUnits=this.SCBWUnits-2;
    };
    
    protected synchronized void increase_bandwidth() {
        String METHOD_NAME = "increase_bandwidth()";
        if (constant.debuglog) debug("agent increaseBW");
        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, "BW increased to " + (this.SCBWUnits+2));
        this.SCBWUnits=this.SCBWUnits+2;
//        if (this.SCBWUnits > 10) {
//            this.SCBWUnits = 10;
//        };
    };
    
    protected void interpret_BroadcastMessage(int Type, Msg currentMessage) {

        if (isDebugEnabled()) { debug("in RESOURCE:interpret_BroadcastMessage ownID= "+ownID+" Broadcast Msg received."); };
        if (Type == constant.MSG_RequestService) {
            currentMessage.broadcast=false;
            if (constant.m_baseline) {
                if (checkRestrictions(currentMessage.itemID)) {
                    interpretRequestService(currentMessage);
                }
            }
            else
                interpretRequestService(currentMessage);        
        } else if ((Type == constant.MSG_RequestResource) && (currentMessage.getRequestingServiceCopy().h != LOCALHP.h)) {
            //Send a CfP to the servicecopy (forward message to interpretCfp with a new Conv_ID
            if (isDebugEnabled()) { debug("in RESOURCE: ownID= "+ownID+"  Broadcast Msg received from "+currentMessage.sender_hp.h); };
            Msg res=new Msg(currentMessage);
            res.setConversation_ID(new Integer(constant.conversation_counter++));
            res.sender_hp = currentMessage.getRequestingServiceCopy();
            res.DocumentType=constant.ASK;
            res.broadcast=false;
            do_Cfp(res);
        } else if (Type == constant.MSG_Plumage) {
            currentMessage.broadcast=false;
            forwardPlumage(currentMessage);
        }
        
        //Broadcasting, send msg to all neighbouring resources
        int i,n;
        n=resourceKnownResources.size();
        for (i=0;i<n;i++) {
            Long elem = (Long)resourceKnownResources.get(i);
            if (elem.longValue() !=ownID) {
                Msg msg_forward=new Msg(currentMessage);
                msg_forward.hop_counter=currentMessage.hop_counter+1;
                msg_forward.setConversation_ID(currentMessage.getConversation_ID());
                msg_forward.sender_hp=new Hp(LOCALHP);
                msg_forward.receiver_hp=new Hp(elem.longValue(), 101);
                if (isDebugEnabled()) { debug("IN RESOURCE: send to neighboring resources "+elem.longValue()+" from "+ownID); };
                msg_forward.broadcast=true;
                goMsg_Dest(Type, msg_forward, msg_forward.receiver_hp);
            }
        }
    };
    
    protected void do_Cfp(Msg currentMessage) {
        //Do CfP for storage
        String METHOD_NAME="doCfp";
        Msg res = new Msg();
        res.itemID = 1;
        res.SC_itemID=currentMessage.SC_itemID;
        res.sender_hp = this.LOCALHP;
        res.receiver_hp = currentMessage.sender_hp;
        res.DocumentType=constant.BID;
        res.setConversation_ID(new Integer(constant.conversation_counter++));
        
        Conversation currentConversation=new Conversation(res.getConversation_ID());
        currentConversation.setLastSentMessage(res);
        currentConversation.setLastReceivedMessage(currentMessage);
        currentConversation.setCorrespondingConversation(currentMessage.getConversation_ID());
        negotiations.put(res.getConversation_ID(), currentConversation);
        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, res.getConversation_ID(), "Resource "+ownID+" sends CfP to SC "+res.receiver_hp.h);
        if (isDebugEnabled()) { debug("do_CFP to SC: "+res.receiver_hp.h); };
        
        //if this is negotiation about storage then give as well information about market situation
        if (total_requests.containsKey(new Integer(currentMessage.SC_itemID))) {
            Integer total_req=(Integer) total_requests.get(new Integer(currentMessage.SC_itemID));
            res.total_requests=total_req.intValue();
        } else {
            res.total_requests=0;
        }
        if (unsatisfied_requests.containsKey(new Integer(currentMessage.SC_itemID))) {
            Integer unsat_req=(Integer) unsatisfied_requests.get(new Integer(currentMessage.SC_itemID));
            res.unsat_requests=unsat_req.intValue();
        } else {
            res.unsat_requests=0;
        }
        if (satisfied_requests.containsKey(new Integer(currentMessage.SC_itemID))) {
            Integer sat_req=(Integer) satisfied_requests.get(new Integer(currentMessage.SC_itemID));
            res.sat_requests=sat_req.intValue();
        } else {
            res.sat_requests=0;
        }
double myNewPrice = strategy.bargain(new Integer(1), constant.BID, 0, -1, res.getConversation_ID());
res.price = myNewPrice;
res.numSCs = 0;
Set scSet = knownServiceCopies.keySet();
Iterator scIt = scSet.iterator();
while(scIt.hasNext()) {
    Long currSCkey = (Long)scIt.next();
    Long currSCitemID = (Long)knownServiceCopies.get(currSCkey);
    if (currSCitemID.longValue() == currentMessage.SC_itemID)
        res.numSCs++;     
}
        goMsg_Dest(constant.MSG_Cfp, res, res.receiver_hp);
    };
    
    protected void postAcceptanceMethod(Msg msg) {
        // PauStrategy
//aqui
//        if (constant.m_baseline) {
            increasePriceDistribution(new Integer(msg.itemID));
//        };

        // INBOX-Stack
        setNegotiating(false);
        if (anyPendingNegotiation()) {
            interpretCfp(getNextPendingNegotiation());
        }
        
        if ((! constant.m_baseline) && (msg.itemID == 0))
            decrease_bandwidth();
    }
    
    public void interpretConfirm(Msg currentMessage) {
        //get Money from SC
        String METHOD_NAME="interpretConfirm()";
        store.log(CLASS_NAME, constant.log_business, METHOD_NAME, ownID, this.LOCALHP.p, currentMessage.getConversation_ID(), "Resource "+ownID+": receives Confirm from "+currentMessage.sender_hp.h + " bwprice: " + currentMessage.bwprice);
        store.log_traffic(1);
        double period = 5;
        
        //schedule end of event
        deallocationSCBWTimer(currentMessage.senderID,period);
        if (constant.m_baseline) {
            currentServingSC.addLast(new Integer(currentMessage.serviceprovider.p));
        } else {
            currentServingSC.addLast(new Integer(currentMessage.sender_hp.p));
        }
        
        if (! constant.m_baseline) {
            negotiations.remove(currentMessage.getConversation_ID());
        } else {
            adaptPriceDistribution(currentMessage.itemID, 1);
        };
        
        if (!constant.m_baseline) {
            learn(currentMessage.price - strategy.getAveragePrice(new Integer (currentMessage.itemID)), new Integer(currentMessage.itemID));
        };
         //store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, currentMessage.getConversation_ID(), "Client is learning: " + (strategy.getAveragePrice(new Integer (currentMessage.itemID)) - currentMessage.price) + " factorID: " +  currentMessage.itemID);   

        if (currentMessage.itemID == 0) {
            if (satisfied_requests.containsKey(new Integer(currentMessage.SC_itemID))) {
                Integer requests=(Integer) satisfied_requests.get(new Integer(currentMessage.SC_itemID));
                int request_int=requests.intValue();
                satisfied_requests.put(new Integer(currentMessage.SC_itemID), new Integer(++request_int));
            } else {
                satisfied_requests.put(new Integer(currentMessage.SC_itemID), new Integer(1));
            }
        }
    }
    
    public void interpretMoneyTransfer(Msg currentMessage) {
        String METHOD_NAME="interpretMoneyTransfer()";
        store.log(CLASS_NAME, constant.log_business, METHOD_NAME, ownID, this.LOCALHP.p, currentMessage.getConversation_ID(), "Resource "+ownID+": increase Budget ("+currentMessage.price+")");
        increaseBudget(currentMessage.price);
        store.log_benefit(currentMessage.price - strategy.getAveragePrice(new Integer (currentMessage.itemID)));
        constant.changeSWF(currentMessage.price - strategy.getAveragePrice(new Integer (currentMessage.itemID)));
        debug("Recurso Budget change: " + currentMessage.price);
    };
    
    protected void deallocationSCBWTimer(int transactionid_, double timeout_) {
        // if (deallocationtimeoutEvent == null) { // schedule a timeout
        
        double now_ = getTime();
        double time_ = now_ + timeout_;
        TM_EVT deallocationtimeoutEvent = null;
        deallocationtimeoutEvent = new TM_EVT(constant.DEALLOC_SC_BW_EVT, transactionid_, time_);
        //if (constant.debuglog) debug("servicecopy "+this+": timeout set at  "+time_);
        setTimeoutAt(deallocationtimeoutEvent, time_);
        
        //      }
    }
    
    protected synchronized void recoverStopTime() {
        if (acumulatedRecovers.size() > 0) {
            decrease_bandwidth();
            currentRecovering.addLast(acumulatedRecovers.removeFirst());
            
            double now_ = getTime();
            double time_ = now_ + ((float) constant.changeTime)/1000;
            TM_EVT deallocationtimeoutEvent = null;
            deallocationtimeoutEvent = new TM_EVT(constant.DEALLOC_SC_BW_EVT_2, 0, time_);
            //if (constant.debuglog) debug("servicecopy "+this+": timeout set at  "+time_);
            setTimeoutAt(deallocationtimeoutEvent, time_);
        }
    }

    public synchronized void addStopTime(int port) {
        Iterator servingSCIt = currentServingSC.iterator();
        while (servingSCIt.hasNext()) {
            int tmp = ((Integer) servingSCIt.next()).intValue();
            if (tmp == port) {
                acumulatedRecovers.addLast(new Integer(port));
            } else {
            }
        }

        Iterator recoveringIt = currentRecovering.iterator();
        while (recoveringIt.hasNext()) {
            int tmp = ((Integer) recoveringIt.next()).intValue();
            if (tmp == port) {
                acumulatedRecovers.addLast(new Integer(port));
            } else {
            }
        }
    }
    
    protected synchronized void timeout(Object evt_) {
        int resourceId = ((TM_EVT)evt_).resourceid;
        double timeout = ((TM_EVT)evt_).timeout;
        
        // Check if timeout was being reset or cancelled
        if (Double.isNaN(timeout))
            return;
        // XX: rounding error if in real-time simulation?
        if (timeout > getTime()) {
            setTimeoutAt(evt_, timeout);
            return;
        }
        
        switch(((TM_EVT)evt_).type) {
            case constant.DEALLOC_SC_BW_EVT:
                increase_bandwidth();
                currentServingSC.removeFirst();
                recoverStopTime();
                break;
                
            case constant.DEALLOC_SC_BW_EVT_2:
                increase_bandwidth();
                currentRecovering.removeFirst();
                recoverStopTime();
                break;
                
            case constant.DEALLOC_BW_EVT:
                break;
                
            case constant.DEALLOC_STORE_EVT:
                break;
            case constant.PAY_TAX:
                if (constant.stopsimulation)
                    return;
                
                if (decreaseBudget(constant.periodically_tax)) {
                    if (isDebugEnabled()) { debug("Periodical Tax of "+constant.periodically_tax+" is paid"); };
                    //Initiate next event
                    double now_ = getTime();
                    double time_ = now_ + periodicalServicesTimeout;
                    TM_EVT pay_taxevent= new TM_EVT(constant.PAY_TAX, ownID, periodicalServicesTimeout);
                    if (isDebugEnabled()) { debug("Agent "+ownID+": next event set at "+time_); };
                    setTimeoutAt(pay_taxevent, time_);
                } else {
                    if (isDebugEnabled()) { debug("No money left."); };
                };
                satisfied_requests.clear();
                unsatisfied_requests.clear();
                total_requests.clear();
                
                clearForwardedMessages();
            break;

        }
    }
    
    public void learn(double gain, Integer factorID) {
        if (! constant.learning)
            return;
        
        String METHOD_NAME="learn";
        //Learn something about that deal
        float profit=(float) gain;
        strategy.getLearningModule().addPrivateInformation(new Float(profit), factorID);
        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, "LEARNING Info: ILearning.PROPAGATE: " + ILearning.PROPAGATE + " getRecommendedLearningAction: " + strategy.getLearningModule().getRecommendedLearningAction() + "=?" + ILearning.PROPAGATE);       
        
        if (((ILearning.PROPAGATE & strategy.getLearningModule().getRecommendedLearningAction()) == ILearning.PROPAGATE)) {
            //prepare broadcast_message
            
            int i,n;
            n=resourceKnownResources.size();
            Integer Conversation_ID=new Integer(constant.conversation_counter++);
            for (i=0;i<n;i++) {
                Long elem = (Long)resourceKnownResources.get(i);
                if (elem.longValue() !=ownID) {
                    Msg plumage_message = new Msg();
                    plumage_message.broadcast=true;
                    plumage_message.sender_hp=this.LOCALHP;
                    plumage_message.setConversation_ID(Conversation_ID);
                    plumage_message.receiver_hp=new Hp(elem.longValue(), 101);
                    Object plumage_object=accept_plumage.get(0);
                    Integer plumage_Integer= (Integer) plumage_object;
                    plumage_message.itemID=plumage_Integer.intValue();
                    plumage_message.setPlumage((Plumage) strategy.getLearningModule().createFitnessInformation(strategy.getLearningModule().getAverageProfit()));
                    
                    goMsg_Dest(constant.MSG_Plumage, plumage_message, plumage_message.receiver_hp); }
                
            }
        strategy.getLearningModule().createFitnessInformation(strategy.getLearningModule().getAverageProfit());
            
            store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, "Plumage sent to known Resources: "+resourceKnownResources);
        }
    };
    /**  Description of the Method
     *
     * @return    Description of the Return Value
     */
    protected boolean checkRestrictions() {
        return true;
    }
    
    public void interpret_Plumage(Msg message) {
        String METHOD_NAME="interpret_Plumage()";
        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, message.getConversation_ID(), "Plumage received  itemID= " + message.itemID + " accept_plumage= " + accept_plumage);
        
        if (accept_plumage.contains(new Integer(message.itemID))) {
            Plumage courterPlumage = (Plumage) message.getPlumage();
            strategy.getLearningModule().addPublicInformation(courterPlumage);
            store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, message.getConversation_ID(), "Genotype now: " + strategy.getMyGenotype() + "Plumage: " + courterPlumage.getSenderGenes());
                      
            if (((ILearning.ADAPT & strategy.getLearningModule().getRecommendedLearningAction()) == ILearning.ADAPT)) {
                strategy.setMyGenotype((Genotype) strategy.getLearningModule().learn(strategy.getMyGenotype()));
                store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, message.getConversation_ID(), "Genotype adapted to: " + strategy.getMyGenotype());
            };
        };
    };
    
    public void setBW(int newBW) {
        SCBWUnits = newBW;
    }
    
    protected synchronized void clearForwardedMessages() {
        int size = forwarded_Conversations.size();
        for (int i=0; i<size/2; i++) {
            Integer currDel = (Integer) forwarded_Conversations.first();
            forwarded_Conversations.remove(currDel);
        }
    }
    
};
