package catnet.servicecopy;

import java.util.*;

import catnet.agent.*;
import catnet.util.Hp;
import catnet.data.Msg;
import catnet.data.*;
import catnet.log.store;
import catnet.data.constant;
import catnet.data.resourceData;
import catnet.util.IntCounter;
import catnet.util.TM_EVT;
import catnet.negotiation.Conversation;
import java.util.Map;
import java.util.TreeMap;
import java.util.HashSet;
import java.util.HashMap;
import java.lang.Math;

/**
 *  Description of the Class
 *
 *@author     Michael Reinicke
 *@created    5. August 2002
 */
public class MasterServiceCopy extends Agent_Source {
    
    String CLASS_NAME="MasterServiceCopy";
    
    int LOCAL_ServiceId;
    
    protected int nEmptyComputings = 0;
    protected boolean thisIsTheFirstTime = true;
    
    long HostResource;

    HashMap SCs;
    TreeMap lASKs, lBIDs;
    HashSet allASKs;
    
    public MasterServiceCopy() {
        super();
        tradeable.addElement(new Integer(0));
        tradeable.addElement(new Integer(1));
        
        if (constant.stock_market) {
            lASKs = new TreeMap();
            lBIDs = new TreeMap();
            allASKs = new HashSet();
        }
        SCs = new HashMap();
    }
    
    /**
     *@param  msg  Description of the Parameter
     */
    /*
     *  Client - Servicecopy Methods
     */
    /**
     *@param  msg  Description of the Parameter
     */
    
    // *********************************************************
    // MasterServiceCopy METHODS
    // *********************************************************
    
    /**
     *@param  resourceAddress  Description of the Parameter
     *@param  msg              Description of the Parameter
     */
    /*
     *  MasterServiceCopy - Resource Methods
     */
    /**
     *@param  resourceAddress  Description of the Parameter
     *@param  msg              Description of the Parameter
     */
    
    /**
     *  Sets the price attribute of the Agent_Source object
     *
     *@param  price  The new price value
     */
    public void setServiceID(int sid) {
        this.LOCAL_ServiceId = sid;
        tradeable.addElement(new Integer(sid));
    }
    
    
    // next method is to be called from doAccept_Client after allocating a resource,
    // to schedule a deallocation with parameter double now_ = getTime();
    
    /**
     *  to be implemented in derived classes. defines what to do with the
     *  acceptance.
     */
    protected void postAcceptanceMethod(){}
    
    protected void postRejectanceMethod(){};
    
    /**  Description of the Method
     *
     * @return    Description of the Return Value
     */
    protected boolean checkRestrictions(int itemID) {
        return true;
    }
    
    public int getServiceID() {
        return this.LOCAL_ServiceId;
    }
    
    protected class SCStatus {
        public boolean isON;
        public double lastUpdate;
    };
    
    protected boolean setStatusSC(Hp currSC, boolean status) {
        Long SCid = new Long((currSC.h<<constant.portBits) + currSC.p);
        if (SCs.containsKey(SCid)) {
            SCStatus currSCStatus = (SCStatus) SCs.get(SCid);
            currSCStatus.isON = status;
            SCs.put(SCid, currSCStatus);
            return currSCStatus.isON;
        } else {
            SCStatus currSCStatus = new SCStatus();
            currSCStatus.isON = status;
            SCs.put(SCid, currSCStatus);
            return currSCStatus.isON;
        }
    }
/*    
    protected boolean setStatusSC(Hp currSC, boolean status) {
        Long SCid = new Long((currSC.h<<constant.portBits) + currSC.p);
        if (SCs.containsKey(SCid)) {
            SCStatus currSCStatus = (SCStatus) SCs.get(SCid);
            if (currSCStatus.lastUpdate + constant.MSCUpdateTime < getTime()) {
                currSCStatus.isON = status;
                currSCStatus.lastUpdate = getTime();
            }
            return currSCStatus.isON;
        } else {
            SCStatus currSCStatus = new SCStatus();
            currSCStatus.isON = status;
            currSCStatus.lastUpdate = getTime();
            SCs.put(SCid, currSCStatus);
            return currSCStatus.isON;
        }
    }
*/    
    
    public void interpretStatus(Msg currentMessage) {
/*if (currentMessage.SCisON)
debug("statussc - setting " + currentMessage.sender_hp + " status to ON");        
else
debug("statussc - setting " + currentMessage.sender_hp + " status to OFF");*/
        setStatusSC(currentMessage.sender_hp, currentMessage.SCisON);
    }
    

    protected boolean getStatusSC(Hp currSC) {
        Long SCid = new Long((currSC.h<<constant.portBits) + currSC.p);
        if (SCs.containsKey(SCid)) {
/*if (((SCStatus) SCs.get(SCid)).isON)
debug("status - MSC - SC " + currSC.h + " SC is ON");
else
debug("status - MSC - SC " + currSC.h + " SC is OFF");*/
            return ((SCStatus) SCs.get(SCid)).isON;
        } else {
            return true;
        }
    }
    
    protected void interpretRequestService(Msg currentMessage) {
        String METHOD_NAME="interpretRequestService";
        Integer conversation_ID = currentMessage.getConversation_ID();
        
        //Store this incoming ASK and BID
        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, "MSC: Request received: Conv: " + currentMessage.getConversation_ID() + " ASK (Resource): " + currentMessage.ASK_price + " BID (Client): " + currentMessage.BID_price);
        
        if ((constant.stock_market) && (thisIsTheFirstTime)) {
            double now_ = getTime();
            double time_ = now_ + constant.msBorsaTime/1000;
            TM_EVT borsa_time = new TM_EVT(constant.BORSA,0, time_);
            setTimeoutAt(borsa_time, time_);
            
            thisIsTheFirstTime = false;
        }
        boolean currStatus = getStatusSC(currentMessage.sender_hp);
        
        // Si l est on, pero suponemos que est off le mandamos un reject para
        // que no espere nada y evitar tener que implementar un algoritmo ms
        // complejo de timeout en el SC
        if (currStatus == false) {
            if (currentMessage.SCisON)
                rejectRequest(currentMessage);
            return;
        }

        //If this is not the first incoming request_service
        if (negotiations.containsKey(conversation_ID)) {
            Conversation currentConversation = (Conversation) negotiations.get(conversation_ID);
            Msg lastBestProposal = (Msg) currentConversation.getLastReceivedMessage();
            // Si ya se ha decidido quien ser el SC
            if (!constant.stock_market) {
                //Version 1
                
                // Si ya se ha decidido quien ser el SC
                if (lastBestProposal == null)
                    return;

                double factor = ((double)currentMessage.hop_counter)/constant.hopfactor;
                currentMessage.price += currentMessage.price*factor;
                currentMessage.hopfactorprice = currentMessage.price*factor;
                
                // Si el precio es mejor, guardamos este en vez del otro
                if ((lastBestProposal.price > currentMessage.price) ||
                (((lastBestProposal.price == currentMessage.price) && (lastBestProposal.hop_counter > currentMessage.hop_counter)))) {
                    currentConversation.otherResources.add(lastBestProposal);
                    currentConversation.setLastReceivedMessage(currentMessage);
                    negotiations.put(conversation_ID, currentConversation);
                }
                else {
                    currentConversation.otherResources.add(currentMessage);
                };
            } else {
                //Version 2
                //Separar BIDs y ASKs del request_service
                //Cada unico conversation solamente tiene un ASK y un o mas BIDs
                //Alamcenar en dos vectores, hashMap o ...
                if (currentMessage.bwprice != -1) {
                    addASK(currentMessage);
                };
            };
        }
        else {
            if (!constant.stock_market) {
                double factor = ((double)currentMessage.hop_counter)/constant.hopfactor;
                currentMessage.price += currentMessage.price*factor;
                currentMessage.hopfactorprice = currentMessage.price*factor;
            }
            
            Conversation currentConversation = new Conversation(System.currentTimeMillis(), conversation_ID, currentMessage, null);
            negotiations.put(conversation_ID, currentConversation);
            
            if (!constant.stock_market) {
                // Ponemos el timeout basandonos en la primera peticin, aunque quiz seria interesante
                // basarse en el time de la peticn del cliente
                double now_ = getTime();
//                double time_ = now_ + 0.05;
                double time_ = now_ + constant.allocationtime;
                TM_EVT decide_service_provider = new TM_EVT(constant.DECIDE_SERVER,conversation_ID.intValue(), time_);
                debug("MSC "+conversation_ID+": timeout set at "+time_+" to decide for SC.");
                setTimeoutAt(decide_service_provider, time_);
                
                time_ = now_ + 5;
                TM_EVT delete_conversation = new TM_EVT(constant.DELETE_CONVERSATION,conversation_ID.intValue(), time_);
                debug("MSC "+conversation_ID+": timeout set at "+time_+" to delete conversation.");
                setTimeoutAt(delete_conversation, time_);
            }
            else {
                if (currentMessage.bwprice != -1) {
                    addASK(currentMessage);
                };
                addBID(currentMessage);
            };
        }
    }

    
    protected void addASK(Msg currentMessage) {
        if (lASKs.containsKey(new Double(currentMessage.ASK_price)))
            ((HashSet) lASKs.get(new Double(currentMessage.ASK_price))).add(currentMessage);
        else {
            HashSet tmpSet = new HashSet();
            tmpSet.add(currentMessage);
            lASKs.put(new Double(currentMessage.ASK_price), tmpSet);
        }
        allASKs.add(currentMessage);
        ((Conversation) negotiations.get(currentMessage.getConversation_ID())).correspondingASKs.add(currentMessage);
    }
    
    protected void addBID(Msg currentMessage) {
        if (lBIDs.containsKey(new Double(currentMessage.BID_price)))
            ((HashSet) lBIDs.get(new Double(currentMessage.BID_price))).add(currentMessage);
        else {
            HashSet tmpSet = new HashSet();
            tmpSet.add(currentMessage);
            lBIDs.put(new Double(currentMessage.BID_price), tmpSet);
        }
    }
    
    
    protected void sendServiceConfirm(Msg currentMessage) {
        String METHOD_NAME = "sendServiceConfirm";
        Msg replyClientMsgAc = null, replyResourceMsgAc = null, replyServieCopyMsgAc = null;
        Msg replyClientMsgCf = null, replyResourceMsgCf = null, replyServieCopyMsgCf = null;

        if (! currentMessage.SCisON) {
            return;
        }
        
        /* *******************************************
         * Enviamos el Accept y el Confirm al serviceCopy
         * ******************************************* */
        replyServieCopyMsgAc=new Msg();
        replyServieCopyMsgAc.hop_counter=0;
        replyServieCopyMsgAc.broadcast=false;
        replyServieCopyMsgAc.setConversation_ID(currentMessage.getConversation_ID());
        replyServieCopyMsgAc.receiver_hp=new Hp(currentMessage.sender_hp);
        replyServieCopyMsgAc.sender_hp=new Hp(LOCALHP);
        replyServieCopyMsgAc.price = currentMessage.price;
        replyServieCopyMsgAc.itemID = currentMessage.itemID;
        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, "MSC: Send accept to " +  replyServieCopyMsgAc.receiver_hp.h + ":" +  replyServieCopyMsgAc.receiver_hp.p + " Price: " + currentMessage.price);
        goMsg_Dest(constant.MSG_Accept, replyServieCopyMsgAc, replyServieCopyMsgAc.receiver_hp);

        replyServieCopyMsgCf=new Msg();
        replyServieCopyMsgCf.hop_counter=0;
        replyServieCopyMsgCf.broadcast=false;
        replyServieCopyMsgCf.setConversation_ID(currentMessage.getConversation_ID());
        replyServieCopyMsgCf.receiver_hp=new Hp(currentMessage.sender_hp);
        replyServieCopyMsgCf.sender_hp=new Hp(LOCALHP);
        replyServieCopyMsgCf.price = currentMessage.price;
        replyServieCopyMsgCf.itemID = currentMessage.itemID;
        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, "MSC: Send confirm to " +  replyServieCopyMsgCf.receiver_hp.h + ":" +  replyServieCopyMsgCf.receiver_hp.p + " Price: " + currentMessage.price);
        goMsg_Dest(constant.MSG_Confirm, replyServieCopyMsgCf, replyServieCopyMsgCf.receiver_hp);

        /* *******************************************
         * Enviamos el Accept y el Confirm al recurso
         * ******************************************* */
        replyResourceMsgAc=new Msg();
        replyResourceMsgAc.hop_counter=0;
        replyResourceMsgAc.broadcast=false;
        replyResourceMsgAc.setConversation_ID(currentMessage.getConversation_ID());
        replyResourceMsgAc.receiver_hp=new Hp(currentMessage.getRequestingResource());
        replyResourceMsgAc.sender_hp=new Hp(LOCALHP);
        replyResourceMsgAc.price=currentMessage.bwprice;
        replyResourceMsgAc.bwprice=currentMessage.bwprice;
        replyResourceMsgAc.hopfactorprice = currentMessage.hopfactorprice;
        replyResourceMsgAc.itemID=0;
        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, "MSC: Send accept to " +  replyResourceMsgAc.receiver_hp.h + ":" +  replyResourceMsgAc.receiver_hp.p + " Price: " + currentMessage.bwprice);
        goMsg_Dest(constant.MSG_Accept, replyResourceMsgAc, replyResourceMsgAc.receiver_hp);

        replyResourceMsgCf=new Msg();
        replyResourceMsgCf.hop_counter=0;
        replyResourceMsgCf.broadcast=false;
        replyResourceMsgCf.setConversation_ID(currentMessage.getConversation_ID());
        replyResourceMsgCf.receiver_hp=new Hp(currentMessage.getRequestingResource());
        replyResourceMsgCf.sender_hp=new Hp(LOCALHP);
        replyResourceMsgCf.price=currentMessage.bwprice;
        replyResourceMsgCf.bwprice=currentMessage.bwprice;
        replyResourceMsgCf.hopfactorprice = currentMessage.hopfactorprice;
        replyResourceMsgCf.serviceprovider = currentMessage.sender_hp;
        replyResourceMsgCf.itemID=0;
        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, "MSC: Send confirm to " +  replyResourceMsgCf.receiver_hp.h + ":" +  replyResourceMsgCf.receiver_hp.p + " Price: " + currentMessage.bwprice);
        goMsg_Dest(constant.MSG_Confirm, replyResourceMsgCf, replyResourceMsgCf.receiver_hp);

        /* *******************************************
         * Enviamos el Accept y el Confirm al cliente
         * ******************************************* */
        replyClientMsgAc=new Msg();
        replyClientMsgAc.hop_counter=0;
        replyClientMsgAc.broadcast=false;
        replyClientMsgAc.itemID=currentMessage.itemID;
        replyClientMsgAc.setConversation_ID(currentMessage.getConversation_ID());
        replyClientMsgAc.receiver_hp=new Hp(currentMessage.getRequestingClient());
        replyClientMsgAc.sender_hp=new Hp(LOCALHP);
        replyClientMsgAc.price = currentMessage.price;
        replyClientMsgAc.bwprice = currentMessage.bwprice;
        replyClientMsgAc.resource = currentMessage.getRequestingResource();
        replyClientMsgAc.serviceprovider = currentMessage.sender_hp;
        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, "MSC: Send accept to " +  replyClientMsgAc.receiver_hp.h + ":" +  replyClientMsgAc.receiver_hp.p + " Price: " + currentMessage.price + " BWPrice: " + currentMessage.bwprice);
        goMsg_Dest(constant.MSG_Accept, replyClientMsgAc, replyClientMsgAc.receiver_hp);
        
        replyClientMsgCf=new Msg();
        replyClientMsgCf.hop_counter=currentMessage.hop_counter+1;
        replyClientMsgCf.broadcast=false;
        replyClientMsgCf.itemID=currentMessage.itemID;
        replyClientMsgCf.setConversation_ID(currentMessage.getConversation_ID());
        replyClientMsgCf.request_ID = currentMessage.getConversation_ID();
        replyClientMsgCf.receiver_hp=new Hp(currentMessage.getRequestingClient());
        replyClientMsgCf.sender_hp=new Hp(LOCALHP);
        replyClientMsgCf.price = currentMessage.price;
        replyClientMsgCf.bwprice = currentMessage.bwprice;
        replyClientMsgCf.hopfactorprice = currentMessage.hopfactorprice;
        replyClientMsgCf.resource = currentMessage.getRequestingResource();
        replyClientMsgCf.serviceprovider = currentMessage.sender_hp;
        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, "MSC: Send confirm to " +  replyClientMsgCf.receiver_hp.h + ":" +  replyClientMsgCf.receiver_hp.p + " Price: " + currentMessage.price + " BWPrice: " + currentMessage.bwprice);
        goMsg_Dest(constant.MSG_Confirm, replyClientMsgCf, replyClientMsgCf.receiver_hp);
    }

    protected void rejectOtherResources(Conversation conv) {

        while (conv.otherResources.size() != 0) {
            Msg currentMessage = (Msg) conv.otherResources.getFirst();
            if (currentMessage.SCisON)
                rejectRequest(currentMessage);
            conv.otherResources.removeFirst();
        }
    }

    protected void rejectRequest(Msg currentMessage) {
        String METHOD_NAME = "rejectRequest";
        Msg rejectResourceMsg = new Msg();
        rejectResourceMsg=new Msg();
        rejectResourceMsg.hop_counter=0;
        rejectResourceMsg.broadcast=false;
        rejectResourceMsg.bwprice = currentMessage.bwprice;
        rejectResourceMsg.setConversation_ID(currentMessage.getConversation_ID());
        rejectResourceMsg.receiver_hp=new Hp(currentMessage.getRequestingResource());
        rejectResourceMsg.sender_hp=new Hp(LOCALHP);
        rejectResourceMsg.itemID = 0;
        rejectResourceMsg.verdict = constant.MSG_Reject;
        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, "MSC: Send reject to " +  rejectResourceMsg.receiver_hp.h + ":" +  rejectResourceMsg.receiver_hp.p + " bwprice: " + rejectResourceMsg.bwprice);
        goMsg_Dest(constant.MSG_Reject, rejectResourceMsg, rejectResourceMsg.receiver_hp);
        
        Msg rejectSCMsg = new Msg(); 
        rejectSCMsg=new Msg(); 
        rejectSCMsg.hop_counter=0; 
        rejectSCMsg.broadcast=false; 
        rejectSCMsg.price = currentMessage.price;
        rejectSCMsg.setConversation_ID(currentMessage.getConversation_ID()); 
        rejectSCMsg.receiver_hp=new Hp(currentMessage.sender_hp); 
        rejectSCMsg.sender_hp=new Hp(LOCALHP); 
        rejectSCMsg.itemID = currentMessage.itemID; 
        rejectSCMsg.verdict = constant.MSG_Reject; 
        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, "MSC: Send reject to " +  rejectSCMsg.receiver_hp.h + ":" +  rejectSCMsg.receiver_hp.p); 
        goMsg_Dest(constant.MSG_Reject, rejectSCMsg, rejectSCMsg.receiver_hp);         
    }
    
    
    protected synchronized void timeout(Object evt_) {
        Integer conversation_ID = new  Integer(((TM_EVT)evt_).resourceid);
        double timeout = ((TM_EVT)evt_).timeout;
        
        // Check if timeout was being reset or cancelled
        if (Double.isNaN(timeout)) 
            return;
        // XX: rounding error if in real-time simulation?
        if (timeout > getTime()) {
            setTimeoutAt(evt_, timeout);
            return;
        }

        switch(((TM_EVT)evt_).type) {
            case constant.DECIDE_SERVER: {
                //Version 1
                debug("MSC " + conversation_ID + ": timeout  "+timeout + " deciding for winner");
                Conversation currentConversation = (Conversation) negotiations.get(conversation_ID);
                Msg bestProposal = (Msg) currentConversation.getLastReceivedMessage();
                sendServiceConfirm(bestProposal);
                rejectOtherResources(currentConversation);
                currentConversation.setLastReceivedMessage(null);
                negotiations.put(conversation_ID, currentConversation);
                
                //Version 2
                //Calcular precio del equillibrium
                //Algoritmo: Como Torsten dijo, 
                //o encontrar un algoritmo que es muy parecido al ejemplo de la pantalla, pero sera muy clavado a lo de Torsten
            }
            break;
            case constant.BORSA: {
                if (lBIDs.size() != 0) {
                    computeBorsa();
                    nEmptyComputings=0;
                }
                else {
                    nEmptyComputings++;
                }
                if (nEmptyComputings < 10) {
                    double now_ = getTime();
                    double time_ = now_ + constant.msBorsaTime/1000;
                    TM_EVT borsa_time = new TM_EVT(constant.BORSA,0, time_);
                    setTimeoutAt(borsa_time, time_);
                }
                else
                    debug("Stopping borsa timer!");
            }
            break;
            case constant.DELETE_CONVERSATION: {
                negotiations.remove(conversation_ID);
            }
            break;
        }
    }
    
    public void computeBorsa() {
        String METHOD_NAME = "computeBorsa()";
        Set allPrices = new TreeSet();
        Map acuBID = new TreeMap();
        Map acuASK = new TreeMap();
        Map surplus = new TreeMap();
        
        // Ponemos en AllPrices todos los precios que hay en ASKs y BIDs
        allPrices.addAll(lBIDs.keySet());
        allPrices.addAll(lASKs.keySet());
        
        int currSurplus, minSurplus = java.lang.Integer.MAX_VALUE;
        Double balancePrice = new Double(0);
        Iterator keyIt = allPrices.iterator();
        // Recorremos todos los precios posibles calculando los BIDs y ASKs acumulados y el surplus
        while (keyIt.hasNext()) {
            Double currKey = (Double) keyIt.next();
            acuBID.put(currKey, calculateAcumulatedBID(acuBID, currKey));
            acuASK.put(currKey, calculateAcumulatedASK(acuASK, currKey));
            surplus.put(currKey, new Integer(((Integer)acuASK.get(currKey)).intValue() - ((Integer)acuBID.get(currKey)).intValue()));
            // Una vez calculado miramos si es menor que el que tenemos
            currSurplus = ((Integer)surplus.get(currKey)).intValue();
            if (java.lang.Math.abs(minSurplus) >  java.lang.Math.abs(currSurplus)) {
                minSurplus = currSurplus;
                balancePrice = currKey;
            }
            else if (java.lang.Math.abs(minSurplus) == java.lang.Math.abs(currSurplus)) {
                // Si hay empate escogemos el positivo, asi servimos el mximo de peticiones
                if (minSurplus != java.lang.Math.max(minSurplus, currSurplus))
                    balancePrice = currKey;
                minSurplus = java.lang.Math.max(minSurplus, currSurplus);
            }
        }
        
// Stuff for printing out results
        System.out.println("borsa - Start");
        Iterator keyIt2 = allPrices.iterator();
        while (keyIt2.hasNext()) {
            Double currKey = (Double) keyIt2.next();
            Integer askAcu = (Integer) acuASK.get(currKey);
            Integer bidAcu = (Integer) acuBID.get(currKey);
            Integer currSur = (Integer) surplus.get(currKey);
            int qtyBID=0, qtyASK=0;
            if (lBIDs.get(currKey) != null)
                qtyBID = ((Set) lBIDs.get(currKey)).size();
            if (lASKs.get(currKey) != null)
                qtyASK = ((Set) lASKs.get(currKey)).size();
            System.out.println("borsa - " + qtyBID + " ][ " + bidAcu + " ][ " + currKey + " (" + currSur + ")" + " ][ " + askAcu + " ][ " + qtyASK);
        }
        System.out.println("borsa - min Surplus es " + minSurplus + " -> preu " + balancePrice);
        System.out.println("borsa - End");
        // Stuff for printing out results

        // Cuando ya tenemos el balance price vamos a calcular el emparejamiento a hacer
        calculateAllocation(balancePrice.floatValue());
        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, "MSC " + ownID + " has calculated equillibrium price " + balancePrice);
        
        // Limpiamos los ASKs y los BIDs para el siguiente clculo
        rejectOtherAKSs();
        lBIDs.clear();
        lASKs.clear();
        allASKs.clear();
    }
    
    protected void calculateAllocation(float balancePrice) {
        HashSet bestMsgs = new HashSet();
        
        // Miramos todos los BIDs hechos
        Set bidSetSet = lBIDs.keySet();
        Iterator bidSetIt = bidSetSet.iterator();
        while (bidSetIt.hasNext()) {
            
            // Cogemos el conjunto de BIDs con ese precio
            Double currBID = (Double) bidSetIt.next();
            Set bidSet = (Set) lBIDs.get(currBID);
            Iterator bidIt = bidSet.iterator();
            while (bidIt.hasNext()) {
                // Cogemos cada uno de los BIDs con ese precio
                Msg currBIDMsg = (Msg) bidIt.next();
                // Si el precio que estaba dispuesto a pagar era menor que el precio de equilibrio
                // no le servimos
                if (currBIDMsg.BID_price < balancePrice)
                    continue;
                
                // Cogemos los ASKs correspondientes
                Conversation currConversation = (Conversation) negotiations.get(currBIDMsg.getConversation_ID());
                
                // Los recorremos todos bsucando el ms cercano
                int bestDist = Integer.MAX_VALUE;
                Msg currBestMsg = null;
                Iterator it = currConversation.correspondingASKs.iterator();
                while (it.hasNext()) {
                    Msg currASKMsg = (Msg) it.next();
                    // Si el ASK_price es mayor que el precio de equilibrio no lo escogemos
                    // y de los que si, escogemos el ms cercano
                    if ((currASKMsg.ASK_price <= balancePrice) && (currASKMsg.hop_counter < bestDist)) {
                        bestDist = currASKMsg.hop_counter;
                        currBestMsg = currASKMsg;
                    }
                }
                // Servimos el servicio digamos ...
                if (currBestMsg != null) {
                    currBestMsg.price = balancePrice;
                    sendServiceConfirm(currBestMsg);
                    // Lo eliminamos de la lista de ASKs para no hacer un reject luego
                    allASKs.remove(currBestMsg);
                }
            }
        }
        
    }
    
    protected void rejectOtherAKSs() {
        Iterator askIt = allASKs.iterator();
        
        while (askIt.hasNext()) {
            Msg currentMessage = (Msg) askIt.next();
            rejectRequest(currentMessage);
        }
    }
    
    
    protected Integer calculateAcumulatedBID(Map acumulated, Double value) {
        int tmpAcu = 0;
        
        SortedMap currBIDPrices = lBIDs.tailMap(value);
        Collection currBIDs = currBIDPrices.values();
        Iterator it = currBIDs.iterator();
        
        while (it.hasNext())
            tmpAcu += ((HashSet) it.next()).size();
        
        return new Integer(tmpAcu);
    }
    
    protected Integer calculateAcumulatedASK(Map acumulated, Double value) {
        int tmpAcu = 0;
        
        SortedMap currASKPrices = lASKs.headMap(new Double(value.doubleValue() + 0.001));
        Collection currASKs = currASKPrices.values();
        Iterator it = currASKs.iterator();
        
        while (it.hasNext())
            tmpAcu += ((HashSet) it.next()).size();
        
        return new Integer(tmpAcu);
    }
    
    /** Getter for property resourceHost.
     * @return Value of property resourceHost.
     */
    public long getResourceHost() {
        return this.HostResource;
    }
    
    /** Setter for property resourceHost.
     * @param resourceHost New value of property resourceHost.
     */
    public void setResourceHost(long HostResource) {
        this.HostResource=HostResource;
    }
    public synchronized void interpretMoneyTransfer(Msg currentMessage) {
    }
    
    protected synchronized void interpretConfirm(Msg currentMessage) {
    }
    
    public void interpret_Plumage(Msg message) {
    }
    
    public void learn(double gain, Integer factorID) {
    }
}