package catnet.servicecopy;

import java.util.*;

import catnet.agent.*;
import catnet.util.Hp;
import java.util.Set;
import catnet.resource.Resource;
import catnet.data.Msg;
import catnet.data.*;
import catnet.log.store;
import catnet.data.constant;
import catnet.data.resourceData;
import catnet.util.IntCounter;
import catnet.util.TM_EVT;
import catnet.negotiation.Conversation;
import java.util.Map;
import catnet.learning.stdea.Genotype;
import catnet.learning.ILearning;
import catnet.learning.stdea.Plumage;

/**
 *  Description of the Class
 *
 *@author     Michael Reinicke
 *@created    5. August 2002
 */
public class ServiceCopy extends Agent_Source {
    
    String CLASS_NAME="ServiceCopy";
    
    int LOCAL_ServiceId;
    
    int total_contracts = 0, total_requests = 0;
    int last_total_contracts = 0, last_total_requests = 0;
    double last_estimated_gain;
    
    double current_costs, estimated_gain;
    
    long HostResource;
    
    boolean available = true;
    public boolean enabled = false;
    
    Hp masterServiceCopy;
    
    /**
     *  Description of the Field
     */
    Map resources = new HashMap();
    
    // Migration stuff
    long migrate_dest;
    boolean migrate = false;
    
    /**
     *  Constructor for the ServiceCopy object
     */
    
    public ServiceCopy() {
        super();
        //Set tradeable itemIDs
        tradeable.addElement(new Integer(0));
        tradeable.addElement(new Integer(1));
        
        //Set plumages to be accepted
        accept_plumage.addElement(new Integer(0));
        accept_plumage.addElement(new Integer(1));
    }
    
    // *********************************************************
    // SERVICECOPY METHODS
    // *********************************************************
    
    //This method sends a cfp to a client, after it has received an accept about bandwidth
    public void doCfp(Conversation currentConversation) {
        String METHOD_NAME="doCfp";
        Msg res = new Msg();
        res.itemID = getServiceID();
        res.sender_hp = this.LOCALHP;
        res.DocumentType=constant.BID;
        Msg myCurrentProposalOfBandwidth = (Msg) currentConversation.getLastReceivedMessage();
        //Get corresponding conversation to read client Hp
        Conversation acceptedNegotiationBW = (Conversation) negotiations.get(currentConversation.getCorrespondingConversation());
        Msg ClientRequest = (Msg) acceptedNegotiationBW.getLastReceivedMessage();
        //hopprice
        double factor = ((double)ClientRequest.hop_counter)/constant.hopfactor;
        myCurrentProposalOfBandwidth.price = myCurrentProposalOfBandwidth.price*(1 + factor);
myCurrentProposalOfBandwidth.hopfactorprice = myCurrentProposalOfBandwidth.price*factor;
currentConversation.setLastReceivedMessage(myCurrentProposalOfBandwidth);
negotiations.put(currentConversation.getConversationID(), currentConversation);
        currentConversation.setLastReceivedMessage(myCurrentProposalOfBandwidth);
        negotiations.put(myCurrentProposalOfBandwidth.getConversation_ID(), currentConversation);
        //hopprice
        Hp dest = ClientRequest.getRequestingClient();
        if (isDebugEnabled()) { debug(dest); };
        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, currentConversation.getConversationID(), "SC "+ownID+ ": " + this.LOCALHP.p + " sends CfP to Client "+dest.h);
        res.setConversation_ID(new Integer(constant.conversation_counter++));
        res.request_ID = currentConversation.getCorrespondingConversation();
        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, res.getConversation_ID(), "Agent "+ownID+"(SC): conversation_ID " + res.getConversation_ID() + "/inicially: " + currentConversation.getCorrespondingConversation()+" allocated to bargain with client");
        if (isDebugEnabled()) { debug("Agent "+ownID+"(SC): conversation_ID "+res.getConversation_ID()+" allocated to bargain with client"); };
        res.receiver_hp = dest;
        //Store new negotiation
        negotiations.put(res.getConversation_ID(), new Conversation(System.currentTimeMillis(), res.getConversation_ID(), null, res, myCurrentProposalOfBandwidth.price, currentConversation.getConversationID()));
        goMsg_Dest(constant.MSG_Cfp, res, dest);
        
    };
    
    public void setServiceID(int sid) {
        this.LOCAL_ServiceId = sid;
        tradeable.addElement(new Integer(sid));
        accept_plumage.addElement(new Integer(sid));
    }
    
    //If Reject then decrease the price
    protected void postRejectanceMethod(Msg msg){
        // PauStrategy
        if (constant.m_baseline) {
                adaptPriceDistribution(getServiceID(), 0);
                return;
        } else {
            if (msg.itemID == 0)
                increasePriceDistribution(new Integer(msg.itemID));
            else
                decreasePriceDistribution(new Integer(msg.itemID));
        };
// ************************        
        
        Conversation currentConversation = (Conversation) negotiations.get( msg.getConversation_ID());
        // Si por el dinamismo hemos borrado la conversacin ya habremos mandado el reject en caso necesario
        if (currentConversation == null)
            return;
        
        Conversation currentResourceConversation = (Conversation) negotiations.get(currentConversation.getCorrespondingConversation());
        if (msg.itemID >= 2) {
            Msg reject_msg = new Msg();
            reject_msg.broadcast=false;
            reject_msg.verdict = constant.MSG_Reject;
            reject_msg.setConversation_ID(currentResourceConversation.getLastReceivedMessage().getConversation_ID());
            reject_msg.itemID = 0;
            reject_msg.receiver_hp=new Hp(currentResourceConversation.getLastReceivedMessage().sender_hp);
            reject_msg.sender_hp=new Hp(LOCALHP);
            goMsg_Dest(constant.MSG_Reject, reject_msg, reject_msg.receiver_hp);
//debug("cfprej - 1.1 - Going to remove coversation " + currentResourceConversation.getCorrespondingConversation());
            negotiations.remove(currentResourceConversation.getCorrespondingConversation());
//debug("cfprej - 1.2 - Going to remove coversation " + currentResourceConversation.getConversationID());
            negotiations.remove(currentResourceConversation.getConversationID());
        } else if (msg.itemID == 0) {
//debug("cfprej - 2 - Going to remove coversation " + currentResourceConversation.getLastReceivedMessage().getConversation_ID());
            negotiations.remove(currentResourceConversation.getLastReceivedMessage().getConversation_ID());
        }
    }
    
    protected void postAcceptanceMethod(Msg msg) {
        if (msg.itemID < 2)
            return;
        
        // INBOX-Stack
        setNegotiating(false);
        if (anyPendingNegotiation()) {
            interpretCfp(getNextPendingNegotiation());
        } else {
// No hacemos el idle computing porque lo haremos en el interpret_MoneyTransfer            
//            idleComputing();
        }
    }
    
    protected void adaptPriceDistribution(int itemID, int confirm) {
        String METHOD_NAME="adaptPriceDistribution()";
        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, "ItemID: " + itemID + " Contract Price: " );        
        if (confirm == 1) {
            increasePriceDistribution(new Integer (itemID));
        } else {
            decreasePriceDistribution(new Integer (itemID));            
            };  
    };
    
    protected boolean checkRestrictions(int itemID) {
        //Implement restrictions here, if needed
        return true;
    }
    
    public int getServiceID() {
        return this.LOCAL_ServiceId;
    }
    
    protected synchronized boolean interpretAccept(Msg currentMessage) {
        //This method may be called after a negotiation for bandwidth (itemID 0) or service
        //For loggging we need the name of the method
        String METHOD_NAME = "interpretAccept";
        boolean done = true;
        
        if (constant.m_baseline == true) {
             return true;
        };
        
        this.executionState = constant.NEGOTIATING;
        Msg replyMsg = null;
        
        Integer factorID = new Integer(currentMessage.itemID);
        Integer conversation_ID = currentMessage.getConversation_ID();
        //intercept mislead message, should not happen
        if (!negotiations.containsKey(conversation_ID)) {
            //require a proposal or cfp
//debug("dinsucks - Recibimos accept de conversacion borrada");
//debug("dinsucks - rejecting to " + currentMessage.sender_hp.h + ":" + currentMessage.sender_hp.p + " for " + factorID);
            goMsg_Dest(constant.MSG_Reject,
            currentMessage.createReply(ownID, constant.MSG_Reject, currentMessage.switchDocumentType(), -1),
            currentMessage.sender_hp);
            store.log(this.CLASS_NAME, constant.log_errors, METHOD_NAME, ownID, this.LOCALHP.p, conversation_ID, " NO CONVERSATION=" + currentMessage);
            this.executionState = constant.IDLE;
            return false;
        }
        
        Conversation currentConversation = (Conversation) negotiations.get(conversation_ID);
        Msg myCurrentProposal = (Msg) currentConversation.getLastSentMessage();
        
        /**
         *  check whether opponents price is -1, means mislead cfp if
         *  (currentMessage.price == -1) { goMsg_Dest(constant.MSG_Cfp,
         *  currentMessage, currentMessage.receiver_hp); return true; }
         */
        
        store.log(this.CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, conversation_ID, "Agent "+ownID+": MSG Accept received");
        
        this.executionState = constant.IDLE;

        //currentConversation.setLastSentMessage(null);
        currentConversation.setLastReceivedMessage(currentMessage);
        negotiations.put(conversation_ID, currentConversation);
        //If this is a conjunct negotiation then
        if (currentConversation.getCorrespondingConversation() != null) {
            if (currentConversation.getBandwidth_price() == 0) {
                //start negotiation with client if this is an accept for bandwidth
                // PauStrategy
                if (factorID.intValue() == 0)
                    decreasePriceDistribution(new Integer(currentMessage.itemID));

                doCfp(currentConversation);
            }
            else { //if negotiation with client is finished then send commit to client and resource
                //Adjust prices of SC
                //Increase price if this is a commit
                if (!constant.m_baseline) {
                    if (myCurrentProposal.itemID > 0) {
                        increasePriceDistribution(new Integer(myCurrentProposal.itemID));
                    } else {
                        decreasePriceDistribution(new Integer(myCurrentProposal.itemID));
                    };
                };
                
                //Commit to resource
                Conversation currentResourceConversation = (Conversation) negotiations.get(currentConversation.getCorrespondingConversation());
                do_Commit(currentResourceConversation, factorID.intValue());
                //Commit to client
                currentConversation.setDistance(currentResourceConversation.getDistance());                    
                do_Commit(currentConversation, currentResourceConversation.getCorrespondingConversation(), factorID.intValue());
                store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p,conversation_ID, "SC "+ownID+" committed");
                if (isDebugEnabled()) { debug("SC "+ownID+" committed"); };
                
                //Remove openCfPs
                if (!constant.m_baseline) {
                    learn(currentMessage.price-strategy.getAveragePrice(factorID), factorID);
                };
                // INBOX-Stack
                setNegotiating(false);
                if (anyPendingNegotiation()) {
                    interpretCfp(getNextPendingNegotiation());
                } else {
                    idleComputing();
                }
                
            };
        } else if (currentMessage.itemID == 1) {
            //This is an accept for storage
            //Move SC and give money to new resource
            if (constant.migration) {
///                debug("migr - Ready to move to " + currentMessage.sender_hp.h);
                migrate_dest = currentMessage.sender_hp.h;
                migrate = true;
                available = false;
                removePendingNegotiations(1);
                
                setNegotiating(false);
                if (anyPendingNegotiation()) {
                    interpretCfp(getNextPendingNegotiation());
                } else {
                    idleComputing();
                }
            }

                };
                

        return true;
    }
    
    protected void increasePriceDistribution(Integer itemID) {
        String METHOD_NAME="increasePriceDistribution()";
        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, "MarketPrices adapted to demand: Old: "+strategy.getLowerLimitPrice(itemID)+"/"+strategy.getUpperLimitPrice(itemID)+" New: "+strategy.getLowerLimitPrice(itemID)*(1+constant.adjustprice2demand)+"/"+strategy.getUpperLimitPrice(itemID)*(1+constant.adjustprice2demand));
        strategy.setPrices(itemID, strategy.getLowerLimitPrice(itemID)*(1+constant.adjustprice2demand/100), strategy.getUpperLimitPrice(itemID)*(1+constant.adjustprice2demand/100));
    };
    
    protected void decreasePriceDistribution(Integer itemID) {
        String METHOD_NAME="decreasePriceDistribution()";
        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, "MarketPrices adapted to demand: Old: "+strategy.getLowerLimitPrice(itemID)+"/"+strategy.getUpperLimitPrice(itemID)+" New: "+strategy.getLowerLimitPrice(itemID)*(1-constant.adjustprice2demand)+"/"+strategy.getUpperLimitPrice(itemID)*(1-constant.adjustprice2demand));
        strategy.setPrices(itemID, strategy.getLowerLimitPrice(itemID)*(1-constant.adjustprice2demand/100), strategy.getUpperLimitPrice(itemID)*(1-constant.adjustprice2demand/100));
    };
    
    protected void interpretRequestService(Msg currentMessage) {
        String METHOD_NAME="interpretRequestService";
        /*
         *1 Ask resource for her price
         *2 send back reply to client with own Price + Resource Price
         *
         *3 negotiate with client until accept or reject comes from client
         *4 send accept or reject to resource
         *5 if resource sends commit, then send commit to client and start delivery service
         *6 if resource sends reject then send reject to the client
         */
        
        if ((! available) && (constant.m_baseline)) {
            if (currentMessage.BID_price == -1)
                return;
            
            Msg msg_reject=new Msg(currentMessage);
            msg_reject.broadcast=false;
            msg_reject.setConversation_ID(currentMessage.getConversation_ID());
            msg_reject.receiver_hp=new Hp(currentMessage.sender_hp);
            msg_reject.sender_hp=new Hp(LOCALHP);
            msg_reject.itemID = -1;
            goMsg_Dest(constant.MSG_Reject, msg_reject, msg_reject.receiver_hp);

            double myNewPrice = strategy.getAveragePrice(new Integer(currentMessage.itemID));
            if (isDebugEnabled()) { debug("Agent " + ownID + "| Conv: " + currentMessage.getConversation_ID().intValue() + ": myNewPrice in interpretCFP: " + myNewPrice); };
            
            Msg msg_forward=new Msg(currentMessage);
            msg_forward.BID_price=currentMessage.BID_price;
            msg_forward.hop_counter=currentMessage.hop_counter;
            msg_forward.broadcast=false;
            msg_forward.setConversation_ID(currentMessage.getConversation_ID());
            msg_forward.receiver_hp=new Hp(masterServiceCopy);
            msg_forward.sender_hp=new Hp(LOCALHP);
            msg_forward.price = myNewPrice + currentMessage.bwprice;
            msg_forward.ASK_price=strategy.getLowerLimitPrice(new Integer(currentMessage.itemID));
            msg_forward.bwprice = currentMessage.bwprice;
            msg_forward.setRequestingClient(currentMessage.getRequestingClient());
            msg_forward.setRequestingResource(currentMessage.sender_hp);
            msg_forward.SCisON = false;            
            store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, currentMessage.getConversation_ID(), "ServiceCopy: "+ownID+" forwarding Request_for_Service to MasterServiceCopy "+ masterServiceCopy.h + ":" + masterServiceCopy.p);
            goMsg_Dest(constant.MSG_RequestService, msg_forward, msg_forward.receiver_hp);
            return;
        }
        else if ((! available) && (! constant.m_baseline)) {
            return;
        }

        
        total_requests++;
        if (constant.m_baseline == false) {
            Conversation currentRequest=new Conversation(currentMessage.getConversation_ID());
            currentRequest.setLastReceivedMessage(currentMessage);
            negotiations.put(currentMessage.getConversation_ID(), currentRequest);
//mem            openCfPs.addElement(new Integer(0));
            Msg res=new Msg();
            res.receiver_hp=new Hp(this.getResourceHost(), 101);
            res.sender_hp=new Hp(this.LOCALHP);
            res.itemID=0;
            res.DocumentType=constant.ASK;
            res.setConversation_ID(new Integer(constant.conversation_counter++));
            store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, currentMessage.getConversation_ID(), "Service Copy "+ ownID + " has received request and now requests bandwidth");
            
            //Create negotiation and conversation object
            Conversation currentConversation=new Conversation(res.getConversation_ID());
            currentConversation.setDistance(currentMessage.hop_counter + 1);
            currentConversation.setLastSentMessage(res);
            currentConversation.setLastReceivedMessage(currentMessage);
            currentConversation.setCorrespondingConversation(currentMessage.getConversation_ID());
            negotiations.put(res.getConversation_ID(), currentConversation);
            
            goMsg_Dest(constant.MSG_Cfp, res, res.receiver_hp);
            /* -> Baseline */
        }
        else {
            Msg replyMsg = null;
            if (!tradeable.contains(new Integer(currentMessage.itemID))) {
                //Error, Reject
                if (isDebugEnabled()) { debug(currentMessage.itemID+" is not tradeable item."); };
                store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, currentMessage.itemID+" is not tradeable item.");
                replyMsg = currentMessage.createReply(ownID, constant.MSG_Reject, currentMessage.switchDocumentType(), 0);
                goMsg_Dest(constant.MSG_Reject, replyMsg, currentMessage.sender_hp);
                return;
            };
            //        Integer factorID = new Integer(currentMessage.itemID);
            //        Integer conversation_ID = currentMessage.getConversation_ID();
            //        if (isDebugEnabled()) { debug("Cfp cID received: " + currentMessage.getConversation_ID()); };
            if (negotiations.containsKey(currentMessage.getConversation_ID())) {
                //do not interpret a second cfp in an ongoing conversation
                if (isDebugEnabled()) { debug("#" + currentMessage.getConversation_ID().intValue() + ": second request service."); };
                goMsg_Dest(constant.MSG_Reject,
                currentMessage.createReply(ownID, constant.MSG_Reject, currentMessage.switchDocumentType(), -1),
                currentMessage.sender_hp);
                return;
            }
            
            double myNewPrice = strategy.getAveragePrice(new Integer(currentMessage.itemID));
            if (isDebugEnabled()) { debug("Agent " + ownID + "| Conv: " + currentMessage.getConversation_ID().intValue() + ": myNewPrice in interpretCFP: " + myNewPrice); };
            
            Msg msg_forward=new Msg(currentMessage);
            msg_forward.BID_price=currentMessage.BID_price;
            msg_forward.hop_counter=currentMessage.hop_counter;
            msg_forward.broadcast=false;
            msg_forward.setConversation_ID(currentMessage.getConversation_ID());
            msg_forward.receiver_hp=new Hp(masterServiceCopy);
            msg_forward.sender_hp=new Hp(LOCALHP);
            msg_forward.price = myNewPrice + currentMessage.bwprice;
            msg_forward.ASK_price=strategy.getLowerLimitPrice(new Integer(currentMessage.itemID));
            msg_forward.bwprice = currentMessage.bwprice;
            msg_forward.setRequestingClient(currentMessage.getRequestingClient());
            msg_forward.setRequestingResource(currentMessage.sender_hp);
            //            if (isDebugEnabled()) { debug("Agent " + ownID + "| Conv: " + conversation_ID.intValue() + ": replyMsg = " + replyMsg + ", curMsg= " + currentMessage); };
            store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, currentMessage.getConversation_ID(), "ServiceCopy: "+ownID+" forwarding Request_for_Service to MasterServiceCopy "+ masterServiceCopy.h + ":" + masterServiceCopy.p);
            goMsg_Dest(constant.MSG_RequestService, msg_forward, msg_forward.receiver_hp);
        }
    }
    
    /** Getter for property resourceHost.
     * @return Value of property resourceHost.
     */
    public long getResourceHost() {
        return this.HostResource;
    }
    
    /** Setter for property resourceHost.
     * @param resourceHost New value of property resourceHost.
     */
    public void setResourceHost(long HostResource) {
        this.HostResource=HostResource;
    }
    
    public void interpretinformResourceHost(Msg message) {
        setResourceHost(message.resource.h);
        setCurrent_Costs(message.price);

        enabled = true;
        
        //pay for period
        decreaseBudget(message.price);
        if (isDebugEnabled()) { debug("Agent "+ownID+": "+getResourceHost()+" is my Host."); };
        if (isDebugEnabled()) { debug("Agent "+ownID+": "+message.price+" payed for upcoming period"); };
    };
    
    public void setCurrent_Costs(double price) {
        current_costs=price;
    };
    
    protected synchronized boolean interpretCfp(Msg currentMessage) {
        // Si es storage negociamos, si no llamamos al interpretProposal
        // para hacer compatible el inbox-stack
        if (currentMessage.itemID == 1)
            return interpretCfpStorage(currentMessage);
//            return super.interpretCfp(currentMessage);
        else
            return interpretProposal(currentMessage);
    }

    
    /**
     *  Description of the Method
     *
     *@param  currentMessage  Description of the Parameter
     *@return                 Description of the Return Value
     */
    protected synchronized boolean interpretProposal(Msg currentMessage) {
        //For logging we need the name of the method
        String METHOD_NAME = "interpretProposal";
        boolean done = true;
        if (isDebugEnabled()) { debug("1 in SERVICECOPY "+ownID+" interpretProposal "+currentMessage.getConversation_ID()+ "  item = "+currentMessage.itemID); };
        
        this.executionState = constant.NEGOTIATING;
        Msg replyMsg = null;
        if (currentMessage.DocumentType == constant.BID) { if (isDebugEnabled()) { debug("Agent: "+ownID+ " Receveived Message is a BID"); };};
        if (currentMessage.DocumentType == constant.ASK) { if (isDebugEnabled()) { debug("Agent: "+ownID+ " Received Message is an ASK"); };};
        
        Integer factorID = new Integer(currentMessage.itemID);
        Integer conversation_ID = currentMessage.getConversation_ID();
        if (!negotiations.containsKey(conversation_ID)) {
            //require a cfp
//debug("dinsucks - Recibimos proposal de conversacion borrada " + conversation_ID);
//debug("dinsucks - rejecting to " + currentMessage.sender_hp.h + ":" + currentMessage.sender_hp.p + " for " + factorID);
            goMsg_Dest(constant.MSG_Reject,
            currentMessage.createReply(ownID, constant.MSG_Reject, currentMessage.switchDocumentType(), -1),
            currentMessage.sender_hp);
            store.log(CLASS_NAME, constant.log_errors, METHOD_NAME, ownID, this.LOCALHP.p, " NO CONVERSATION=" + currentMessage);
            this.executionState = constant.IDLE;
            return false;
        }
        
        // INBOX-Stack
        if(currentMessage.itemID >= 1) {
            if (isNegotiating() && !isNegotiatingWith(conversation_ID.intValue())) {
                addPendingNegotiation(currentMessage);
                return false;
            }
            else {
                setNegotiating(conversation_ID.intValue());
            }
        }
        
        Conversation currentConversation = (Conversation) negotiations.get(conversation_ID);
        Msg myCurrentProposal = (Msg) currentConversation.getLastSentMessage();
        
        double hisCurrentProposal;
        double ownCurrentProposal;
        if (isDebugEnabled()) { debug("2 in SERVICECOPY "+ownID+" interpretProposal "+currentMessage.getConversation_ID()+ "  item = "+currentMessage.itemID); };
        
        //If Bandwidth_price is set, then this is a negotiation with a client who
        //wants to get a service. Substract the price for bandwidth for the negotiation
        if (currentConversation.getBandwidth_price()  > 0) {
            hisCurrentProposal=currentMessage.price-currentConversation.getBandwidth_price();
            ownCurrentProposal=myCurrentProposal.price-currentConversation.getBandwidth_price();
            if (constant.debuglog) System.out.println("currentMessage.price=" + currentMessage.price + " myCurrentProposal.price= "+ myCurrentProposal.price + " currentConversation.getBandwidth_price()= " + currentConversation.getBandwidth_price());
        }
        else {
//migraqui            
/*            if (currentMessage.itemID == 1) {
                //This is a negotiation about replacement
                if (isDebugEnabled()) { debug("Resource/itemID/Total Requests/Unsatisfied Requests/Gain/Costs: "+currentMessage.sender_hp.h+"/"+currentMessage.SC_itemID+"/"+currentMessage.total_requests+"/"+currentMessage.unsat_requests+"/"+estimated_gain+"/"+current_costs); };
//debug("migr - prop - Resource/itemID/Total Requests/Unsatisfied Requests/Gain/Costs: "+currentMessage.sender_hp.h+"/"+currentMessage.SC_itemID+"/"+currentMessage.total_requests+"/"+currentMessage.unsat_requests+"/"+estimated_gain+"/"+current_costs);
                hisCurrentProposal=((estimated_gain-current_costs)*Math.exp(currentMessage.unsat_requests/currentMessage.total_requests))-currentMessage.price;
                ownCurrentProposal=((estimated_gain-current_costs)*Math.exp(currentMessage.unsat_requests/currentMessage.total_requests))-myCurrentProposal.price;
//debug("migr - prop - his/own: "+hisCurrentProposal+"/"+ownCurrentProposal);;
                if (isDebugEnabled()) { debug("his/own: "+hisCurrentProposal+"/"+ownCurrentProposal); };
            }
            else {
*/                //This is a normal negotiation
                hisCurrentProposal=currentMessage.price;
                ownCurrentProposal=myCurrentProposal.price;
/*            };
*/        };
        /**
         *  check whether opponents price is -1, means mislead cfp if
         *  (currentMessage.price == -1) { goMsg_Dest(constant.MSG_Cfp,
         *  currentMessage, currentMessage.receiver_hp); return true; }
         */
        
        //if offers match, clear replyMsg
        Integer Integer_itemID = new Integer(currentMessage.itemID);
        //store.log(this.CLASS_NAME, constant.log_infos, METHOD_NAME, "Offers match");
        
        if (checkRestrictions(currentMessage.itemID)) {
            
            if (isDebugEnabled()) { debug("3 in SERVICECOPY "+ownID+" interpretProposal "+currentMessage.getConversation_ID()+ "  item = "+currentMessage.itemID); };
            
            double myNewPrice = strategy.bargain(factorID, currentMessage.switchDocumentType(), hisCurrentProposal, ownCurrentProposal, conversation_ID);
            if (constant.debuglog) System.out.println("myNewPrice = " + myNewPrice);
            if (isDebugEnabled()) { debug("5 in SERVICECOPY myNewPrice="+myNewPrice); };
            if  (currentConversation.getBandwidth_price()  > 0) {
                myNewPrice=myNewPrice+currentConversation.getBandwidth_price();
                if (isDebugEnabled()) { debug("6 in SERVICECOPY myNewPrice="+myNewPrice); };
            };
            
            if (isDebugEnabled()) { debug("4 in SERVICECOPY "+ownID+" interpretProposal "+currentMessage.getConversation_ID()+ "  item = "+currentMessage.itemID); };
            
            if (isDebugEnabled()) { debug("Agent " + ownID + " | "+"Conv: " + conversation_ID + ": myNewPrice in interpretPROPOSAL=" + myNewPrice); };
            store.log(this.CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, currentMessage.getConversation_ID(), "myNewPrice in interpretPROPOSAL=" + myNewPrice);
            
            switch (strategy.getRecommendedAction()) {
                case constant.MSG_Proposal:
                    replyMsg = currentMessage.createReply(ownID, constant.MSG_Proposal, currentMessage.switchDocumentType(), myNewPrice);
                    store.log(this.CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, conversation_ID, "SEND NEW PROPOSAL -- MESSAGE=" + replyMsg);
                    this.executionState = constant.NEGOTIATING;
                    break;
                case constant.MSG_Reject:
                    replyMsg = currentMessage.createReply(ownID, constant.MSG_Reject, currentMessage.switchDocumentType(), myNewPrice);
                    store.log(this.CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, conversation_ID, "SEND REJECTED -- MESSAGE=" + replyMsg);
                    this.executionState = constant.IDLE;
                    //Do something that changes the price due to the sum of contracts
                    postRejectanceMethod(currentMessage);
                    break;
                case constant.MSG_Accept:
                    replyMsg = currentMessage.createReply(ownID, constant.MSG_Accept, currentMessage.switchDocumentType(), myNewPrice);
                    store.log(this.CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, conversation_ID, "SEND ACCEPTED -- MESSAGE=" + replyMsg + myCurrentProposal);
                    this.executionState = constant.NEGOTIATING;
                    //Do something that changes the price due to the sum of contracts
                    // PauStrategy
                    if (factorID.intValue() == 0)
                        decreasePriceDistribution(new Integer(currentMessage.itemID));
                    else
                        increasePriceDistribution(new Integer(currentMessage.itemID));
                    
                    //Learn
                    if (!constant.m_baseline) {
                        learn(currentMessage.price-strategy.getAveragePrice(factorID), factorID);
                    };
                    break;
            }
            if (isDebugEnabled()) { debug("Agent " + ownID + "| Conv: " + conversation_ID + ": replyMsg = " + replyMsg + ", curMsg= " + currentMessage); };
            store.log(CLASS_NAME, constant.log_business, METHOD_NAME, ownID, this.LOCALHP.p, conversation_ID, "SC "+ownID+": propose "+myNewPrice+" to Agent "+currentMessage.sender_hp.h+": "+currentMessage.sender_hp.h);
            currentConversation.setLastSentMessage(replyMsg);
            currentConversation.setLastReceivedMessage(currentMessage);
            negotiations.put(conversation_ID, currentConversation);
            
            //If this is an accept in a negotiation about providing a service
            if ((replyMsg.verdict == constant.MSG_Accept) && (currentConversation.getCorrespondingConversation() != null)) {
                goMsg_Dest(replyMsg.verdict, replyMsg, currentMessage.sender_hp);
                if (currentConversation.getBandwidth_price() == 0) {
                    //Negotiate with client
                    doCfp(currentConversation);
                } else {
                    //This was an accept with client, so commit to both
                    if (isDebugEnabled()) { debug("Commit"); };
                    
                    //Commit to resource
                    Conversation currentResourceConversation = (Conversation) negotiations.get(currentConversation.getCorrespondingConversation());
                    do_Commit(currentResourceConversation, factorID.intValue());
                    //Commit to client
                    currentConversation.setDistance(currentResourceConversation.getDistance());                    
                    do_Commit(currentConversation, currentResourceConversation.getCorrespondingConversation(), factorID.intValue());
                    store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, conversation_ID, "SC "+ownID+" committed");
                    if (isDebugEnabled()) { debug("SC "+ownID+" committed"); };
                    
                    //Remove openCfPs
//mem                    openCfPs.remove(new Integer(0));
                    
                }
            } else {
                //reply reject or proposal
///                if (Integer_itemID.intValue() != 1)
///                    replyMsg.request_ID = ((Conversation) negotiations.get(currentConversation.getCorrespondingConversation())).getCorrespondingConversation();
                store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, conversation_ID, "SC "+ownID+" rejects");
                goMsg_Dest(replyMsg.verdict, replyMsg, currentMessage.sender_hp);
            };

            if (replyMsg.verdict == constant.MSG_Accept) {
                if (currentMessage.itemID == 1)
                    negotiations.remove(currentMessage.getConversation_ID());
            } else if (replyMsg.verdict == constant.MSG_Reject) {
                negotiations.remove(currentMessage.getConversation_ID());
            }
            
            if ((replyMsg.verdict != constant.MSG_Proposal)  && (factorID.intValue() >= 1)) {
                setNegotiating(false);
                if (anyPendingNegotiation()) {
                    interpretCfp(getNextPendingNegotiation());
                } else {
                    idleComputing();
                }
            }
            
            if ((replyMsg.verdict == constant.MSG_Accept) && (replyMsg.itemID == 1)) {
                //Accept in storage negotiation
                if (constant.migration) {
///                    debug("migr - Ready to move to " + currentMessage.sender_hp.h);
                    migrate_dest = currentMessage.sender_hp.h;
                    migrate = true;
                    available = false;
                    removePendingNegotiations(1);
                    
                    setNegotiating(false);
                    if (anyPendingNegotiation()) {
                        interpretCfp(getNextPendingNegotiation());
                    } else {
                        idleComputing();
                    }
                }
            };
            return true;
        } else {
            //check restrictions = false
            //immediately reject
            return false;
        }
    }
    
    protected synchronized void interpretConfirm(Msg currentMessage) {
        //Add traffic; free the service; Money Flow is initiated by the client
        //After migration put estimated_gain to 0 
        //aqui - si ho comentem surten dues linies de preus
        if (constant.m_baseline)
            adaptPriceDistribution(getServiceID(), 1);
    }
    
    public synchronized void interpretMoneyTransfer(Msg currentMessage) {
        //Increase my own budget
        //Decrease it by the price for the resource
        //Send message
        String METHOD_NAME="interpretMoneyTransfer()";

        Integer conversation_ID = currentMessage.getConversation_ID();
        if ((! constant.m_baseline) && (!negotiations.containsKey(conversation_ID))) {
            //require a cfp
            store.log(CLASS_NAME, constant.log_errors, METHOD_NAME, ownID, this.LOCALHP.p, " NO CONVERSATION=" + currentMessage);
            this.executionState = constant.IDLE;
            return;
        }
        
        increaseBudget(currentMessage.price);

        Msg bwMessage=null;
        Msg message=new Msg();
        Conversation currentConversation = (Conversation) negotiations.get(currentMessage.getConversation_ID());
        Conversation correspondingConversation = currentConversation; // Stuff to avoid java error
        if (constant.m_baseline == false) {
            correspondingConversation = (Conversation) negotiations.get(currentConversation.getCorrespondingConversation());
            Msg correspondingMessage = (Msg) correspondingConversation.getLastSentMessage();
            message.setConversation_ID(correspondingConversation.getConversationID());
            message.receiver_hp=correspondingMessage.receiver_hp;
            //debug("wttf - ["+currentMessage.getConversation_ID()+"] - Service costs " + (currentMessage.price - currentConversation.getBandwidth_price() - correspondingMessage.hopfactorprice));
            
            message.price=currentConversation.getBandwidth_price() - correspondingMessage.hopfactorprice;
            bwMessage = (Msg) correspondingConversation.getLastReceivedMessage();
            estimated_gain=estimated_gain+currentMessage.price-currentConversation.getBandwidth_price()-bwMessage.hopfactorprice;
            if (currentMessage.itemID > 1) {
                total_contracts++;
            }
        }
        else {
            bwMessage = currentMessage;
            message.setConversation_ID(currentMessage.getConversation_ID());
            message.price=currentMessage.bwprice;
            message.receiver_hp=currentMessage.resource;
            }
        message.sender_hp=this.LOCALHP;
        store.log(CLASS_NAME, constant.log_business, METHOD_NAME, ownID, this.LOCALHP.p, currentMessage.getConversation_ID(), "SC "+ownID+" received "+currentMessage.price+" by client "+currentMessage.sender_hp.h+" and gives "+ (message.price - bwMessage.hopfactorprice)+" to Resource "+ message.receiver_hp.h + " and "+bwMessage.hopfactorprice+" to the Network");

        message.price -= bwMessage.hopfactorprice;
        // Pagamos al recurso por el ancho de banda
        if (decreaseBudget(message.price)) {
            goMsg_Dest(constant.MSG_MoneyTransfer, message, message.receiver_hp);
        };
        // Pagamos a la red de forma teorica
        decreaseBudget(bwMessage.hopfactorprice);
        
        //Log Benefit of Transaction to DB
        //Bargain minus AveragePrice
        store.log_benefit( (currentMessage.price - message.price - bwMessage.hopfactorprice) - strategy.getAveragePrice(new Integer (currentMessage.itemID)));
        constant.changeSWF((currentMessage.price - message.price - bwMessage.hopfactorprice) - strategy.getAveragePrice(new Integer (currentMessage.itemID)));
        debug("SC Budget change: " + (currentMessage.price-message.price-bwMessage.hopfactorprice));
        
        message=new Msg();
        /*if (constant.m_baseline == false) {
            Msg LastMessage= (Msg) currentConversation.getLastReceivedMessage();
            message.receiver_hp = LastMessage.sender_hp;
        }
        else {
            message.receiver_hp=currentMessage.getRequestingClient();
        }*/
        message.receiver_hp = currentMessage.sender_hp;
        message.sender_hp=this.LOCALHP;
        //            store.log(CLASS_NAME, constant.log_business, METHOD_NAME, ownID, "SC "+ownID+" received "+currentMessage.price+" by client "+currentMessage.sender_hp.h+" and gives "+message.price+" to Resource "+ message.receiver_hp.h);
        goMsg_Dest(constant.MSG_ProvideService, message, message.receiver_hp);
        
        if (constant.m_baseline == false) {
            //Remove negotiations from HashMap
            negotiations.remove(currentConversation.getConversationID());
            negotiations.remove(correspondingConversation.getConversationID());
            negotiations.remove(correspondingConversation.getCorrespondingConversation());
        }
  
        idleComputing();
    }
    
    public void setMasterServiceCopy(long msc_h, int msc_p) {
        masterServiceCopy = new Hp(msc_h, msc_p);
    }
    
    public void initiate_Replacement() {
        String METHOD_NAME="do_Replacement()";
//mem        openCfPs.addElement(new Integer(1));
        
         /*1 Create new message and send it to hosting resource
             (Ressource forwards it to its neighbours until hop_counter exceeds)
          *
           2 Get CfPs and begin to negotiate
             (use INBOX-Stack)
          *3 if commit, then give money to the resource and move to new host
          *4 inform host about the new service and itemID
          */
            Msg msg=new Msg();
            msg.receiver_hp=new Hp(getResourceHost(), 101);
            msg.sender_hp=LOCALHP;
            //1 stands for storage
            msg.itemID=1;
            msg.SC_itemID=this.LOCAL_ServiceId;
            msg.DocumentType=constant.ASK;
            msg.hop_counter=0;
            msg.setRequestingServiceCopy(LOCALHP);
            msg.broadcast=true;
            msg.setConversation_ID(new Integer(constant.conversation_counter++));
            store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, "SC "+ownID+" sends Request to Resource "+getResourceHost());
            
            //Send message to hosting resource
            Hp dest=new Hp(getResourceHost(), 101);
            goMsg_Dest(constant.MSG_RequestResource, msg, dest);
// No guardamos la conversacin porque no la hacemos servir para nada            
//            negotiations.put(msg.getConversation_ID(), new Conversation(System.currentTimeMillis(), msg.getConversation_ID(), null, msg));
        };
    
    protected synchronized void timeout(Object evt_) {
        int resourceId = ((TM_EVT)evt_).resourceid;
        double timeout = ((TM_EVT)evt_).timeout;
        //debug("agent "+resourceId+": timeout  "+timeout);
        
        if (constant.stopsimulation)
            return;
        
        // Check if timeout was being reset or cancelled
        if (Double.isNaN(timeout))
            return;
        // XX: rounding error if in real-time simulation?
        if (timeout > getTime()) {
            setTimeoutAt(evt_, timeout);
            return;
        }
        
        switch(((TM_EVT)evt_).type) {
            case constant.PAY_TAX:
                if (decreaseBudget(constant.periodically_tax)) {
                    //                        if (isDebugEnabled()) { debug("Periodical Tax of "+constant.periodically_tax+" is paid"); };
                    //Initiate next event
                    double now_ = getTime();
                    double time_ = now_ + periodicalServicesTimeout;
                    TM_EVT pay_taxevent= new TM_EVT(constant.PAY_TAX, ownID, periodicalServicesTimeout);
                    //                        if (isDebugEnabled()) { debug("Agent "+ownID+": next event set at "+time_); };
                    setTimeoutAt(pay_taxevent, time_);
                    last_estimated_gain=estimated_gain;
                    last_total_contracts=total_contracts;
                    last_total_requests=total_requests;
                    estimated_gain=0;
                    total_contracts=0;
                    total_requests=0;
                } else {
                    //                        if (isDebugEnabled()) { debug("No money left."); };
                };
                
                break;
                
            case constant.REPLACEMENT:
                //                     if (isDebugEnabled()) { debug("doREplace"); };
                if (money_balance > 0) {
                    // Si estamos pendientes de migracin entonces no o si estamos apagados tampoco
                    if ((! migrate) && (available)) {
//debug("migr");
//debug("migr - Starting negotiations for storage");
                        initiate_Replacement();
                    }
                    
                    //Initiate next event
                    double now_ = getTime();
                    double time_ = now_ + periodicalServicesTimeout;
                    //                        if (isDebugEnabled()) { debug("Next Periodical Replacement terminated"); };
                    TM_EVT initiate_Replacement= new TM_EVT(constant.REPLACEMENT, ownID, periodicalServicesTimeout);
                    setTimeoutAt(initiate_Replacement, time_);
                };
                break;
                
        }
    }
    
    //Only once called by TCL-Script
    public void start_periodical_services(double timeout_) {
        
        
        periodicalServicesTimeout = timeout_;
        
        if (! enabled)
            return;
        
        double now_ = getTime();
        double time_ = now_ + timeout_;
        TM_EVT pay_taxevent= new TM_EVT(constant.PAY_TAX, ownID, time_);
        //debug("Agent "+ownID+": timeout set at "+time_+" to pay tax.");
        
        setTimeoutAt(pay_taxevent, time_);
        
        if ((constant.migration) && (! constant.m_baseline)) {
            TM_EVT initiate_Replacement= new TM_EVT(constant.REPLACEMENT, ownID, time_);
            //        if (isDebugEnabled()) { debug("Replace scheduled"); };
            //        debug("agent "+ownID+": timeout set at "+time_+" to replace.");
            setTimeoutAt(initiate_Replacement, time_);
        }
    };

    public void learn(double gain, Integer factorID) {
        if (! constant.learning)
            return;
        
        String METHOD_NAME="learn";
        //Learn something about that deal
        float profit=(float) gain;
        strategy.getLearningModule().addPrivateInformation(new Float(profit), factorID);
        
        if ((ILearning.PROPAGATE & strategy.getLearningModule().getRecommendedLearningAction()) == ILearning.PROPAGATE) {
            //prepare broadcast_message
            Msg plumage_message = new Msg();
            plumage_message.broadcast=true;
            plumage_message.sender_hp=this.LOCALHP;
            plumage_message.setConversation_ID(new Integer(constant.conversation_counter++));
            plumage_message.receiver_hp=new Hp(getResourceHost(), 101);
            
            //What is this agent trading?
            //If several things, then indicate first to recipients (SC:0, 1, itemID)
            Object plumage_object=accept_plumage.get(0);
            Integer plumage_Integer= (Integer) plumage_object;
            plumage_message.itemID=plumage_Integer.intValue();
            plumage_message.setPlumage((Plumage) strategy.getLearningModule().createFitnessInformation(strategy.getLearningModule().getAverageProfit()));
                    
            store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, plumage_message.getConversation_ID(), "Plumage sent. ");
            goMsg_Dest(constant.MSG_Plumage, plumage_message, plumage_message.receiver_hp);
        }
        strategy.getLearningModule().createFitnessInformation(strategy.getLearningModule().getAverageProfit());                
    };

    public void interpret_Plumage(Msg message) {
        String METHOD_NAME="interpret_Plumage()";
        store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, message.getConversation_ID(), " Plumage received; itemID= " + message.itemID + " accept_plumage= " + accept_plumage);
        if (accept_plumage.contains(new Integer(message.itemID))) {
            Plumage courterPlumage = (Plumage) message.getPlumage();
            strategy.getLearningModule().addPublicInformation(courterPlumage);
            store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, message.getConversation_ID(), "Genotype now: " + strategy.getMyGenotype() + "Plumage: " + courterPlumage.getSenderGenes());
            
            if (((ILearning.ADAPT & strategy.getLearningModule().getRecommendedLearningAction()) == ILearning.ADAPT) || (1 == 1)) {
                strategy.setMyGenotype((Genotype) strategy.getLearningModule().learn(strategy.getMyGenotype()));
                store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID,  this.LOCALHP.p, message.getConversation_ID(), "Genotype adapted to: " + strategy.getMyGenotype());
            };
        };
    };
    
    public synchronized boolean enableServiceCopy(boolean state) {
        boolean tmp = available;
        if (enabled) {
            if (! state) {
//debug("dinsucks - Apagamos el SC");
                stopCurrentNegotiations();
            }
            available = state;
        }

        return tmp;
    }

    public synchronized void addStopTime() {
        Resource currR = (Resource) (this.getParent()).getComponent("resource");
        currR.addStopTime(LOCALHP.p);
    }
    
    protected void stopCurrentNegotiations() {

        setNegotiating(false);
        // So that if we are negotiating and we receive a a proposal/accept/... we reject
        Set negotiationsKeySet = negotiations.keySet();
        Iterator negotiationsIt = negotiationsKeySet.iterator();
        while (negotiationsIt.hasNext()) {
            Conversation currNegotiation = (Conversation) negotiations.get(negotiationsIt.next());
            if (currNegotiation.getBandwidth_price() != 0) {
                // Si hemos negociado ya con el R lengthtenemos que mandar un reject
                Conversation currentResourceConversation = (Conversation) negotiations.get(currNegotiation.getCorrespondingConversation());
                Msg reject_msg = new Msg();
                reject_msg.broadcast=false;
                reject_msg.verdict = constant.MSG_Reject;
                reject_msg.setConversation_ID(currentResourceConversation.getLastReceivedMessage().getConversation_ID());
                reject_msg.itemID = 0;
                reject_msg.receiver_hp=new Hp(currentResourceConversation.getLastReceivedMessage().sender_hp);
                reject_msg.sender_hp=new Hp(LOCALHP);
//debug("dinsucks - Sending a reject to R " + reject_msg.receiver_hp.h + ":" + reject_msg.receiver_hp.p + " for itemID " + reject_msg.itemID + " on " + reject_msg.getConversation_ID());
                goMsg_Dest(constant.MSG_Reject, reject_msg, reject_msg.receiver_hp);
            }
            
        }
        
        negotiations.clear();

        // We send a reject to the Clients that sent us a Proposal
        while (anyPendingNegotiation()) {
            Msg currentMessage = getNextPendingNegotiation();
            Msg msg_reject=new Msg(currentMessage);
            msg_reject.broadcast=false;
            msg_reject.setConversation_ID(currentMessage.getConversation_ID());
            msg_reject.receiver_hp=new Hp(currentMessage.sender_hp);
            msg_reject.sender_hp=new Hp(LOCALHP);
            msg_reject.itemID = currentMessage.itemID;
//debug("dinsucks - Sending a reject to SC " + msg_reject.receiver_hp.h + ":" + msg_reject.receiver_hp.p + " for itemID " + currentMessage.itemID + " on " + currentMessage.getConversation_ID());
            goMsg_Dest(constant.MSG_Reject, msg_reject, msg_reject.receiver_hp);
        }
        // porsiaca
        removePendingNegotiations();
    }
    
    public synchronized boolean isEnabledServiceCopy() {
        return available;
    }
    
    public void idleComputing() {
        if ((constant.migration) && (migrate)) {
            // Miramos si aun tiene negociaciones con algun cliente pendientes, es decir,
            // ha mandado el Cfp, pero no ha recibido el proposal/reject an
            if (negotiations.size() <= 1) {
debug("migr - migramos");                
                negotiations.clear();;
                migracio(migrate_dest);
                last_estimated_gain=0;
                last_total_contracts=0;
                last_total_requests=0;
                estimated_gain=0;
                total_contracts=0;
                total_requests=0;
                migrate = false;
                available = true;
            } else {
///                debug("migr - No empezamos migracin porque tiene algun Cfp enviado " + negotiations.toString());
            }
        }
    }
    
    public synchronized void migracio(long dest) {
        debug("migration - Migrating !");
        debug("migr");
        //This is an accept for storage
        //Move SC and give money to new resource
        drcl.comp.Component root_ = (this.getParent()).getParent();
        drcl.comp.Component source_ = this.getParent();
        //currentMessage.sender_hp.h
        //debug("migration - Moving to n" + dest);
        drcl.comp.Component destination_ = root_.getComponent("n" + dest);
        drcl.comp.Component sc_ = (this.getParent()).getComponent("servicecopy" + LOCALHP.p);
        
        Resource currR = (Resource) (this.getParent()).getComponent("resource");
        currR.removeKnownServiceCopy(new Hp(LOCALHP));
        //debug("migration - Removed from parent");
        
        sc_.getPort("down").disconnect();
        drcl.comp.Port[] peers_ = (sc_.getPort("down")).getPeers();
        if (1==peers_.length) {
            source_.getComponent("udp").removePort(peers_[0]);
        }
        source_.removeComponent(sc_);
        
        Resource destR = (Resource) destination_.getComponent("resource");
        int destPort = destR.getFreePort();
        //debug("migration - We will be in port " + destPort);
        destR.addKnownServiceCopy(dest, destPort, LOCAL_ServiceId);
        sc_.setName("servicecopy" + destPort);
        sc_.setID("servicecopy" + destPort);
        destination_.addComponent(sc_);
        //debug("migration - Disconnected everything");
        sc_.getPort("down").connect(
        (destination_.getComponent("udp")).addPort("up", "" + destPort));
        
        LOCALHP.h = dest;
        LOCALHP.p = destPort;
        ownID = (int) dest;
    }
    
    public void sendStatus() {
        Msg msg_status=new Msg();
        msg_status.broadcast=false;
        msg_status.receiver_hp=new Hp(masterServiceCopy);
        msg_status.sender_hp=new Hp(LOCALHP);
        msg_status.verdict = constant.MSG_Status;
        msg_status.SCisON = enabled && available;
        goMsg_Dest(constant.MSG_Status, msg_status, msg_status.receiver_hp);
    }
    
// -----------------------------------------------------------------------------------
    
    protected synchronized boolean interpretCfpStorage(Msg currentMessage) {
        String METHOD_NAME = "interpretCfp";
        boolean done = true;
        Integer factorID = new Integer(currentMessage.itemID);
        Integer conversation_ID = currentMessage.getConversation_ID();
        
        this.executionState = constant.NEGOTIATING;
        Msg replyMsg = null;
        //Check if this a tradeable item
        if (!tradeable.contains(new Integer(currentMessage.itemID))) {
            //Error, Reject
            if (isDebugEnabled()) { debug(currentMessage.itemID+" is not tradeable item."); };
            store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, conversation_ID, currentMessage.itemID+" is not tradeable item.");
            replyMsg = currentMessage.createReply(ownID, constant.MSG_Reject, currentMessage.switchDocumentType(), 0);
            goMsg_Dest(constant.MSG_Reject, replyMsg, currentMessage.sender_hp);
            return false;
        };
        if ((!openCfPs.contains(currentMessage.request_ID)) && (currentMessage.itemID >= 2)) {
            //Error, Reject
            if (isDebugEnabled()) { debug(currentMessage.itemID+" is not requested."); };
            store.log(CLASS_NAME, constant.log_infos, METHOD_NAME, ownID, this.LOCALHP.p, conversation_ID, currentMessage.itemID+" is not requested.");
            replyMsg = currentMessage.createReply(ownID, constant.MSG_Reject, currentMessage.switchDocumentType(), 0);
            goMsg_Dest(constant.MSG_Reject, replyMsg, currentMessage.sender_hp);
            return false;
        };
        
        if (isDebugEnabled()) { debug("Cfp cID received: " + currentMessage.getConversation_ID()); };
        
        if (negotiations.containsKey(conversation_ID)) {
//debug("dinsucks - Recibimos cfp de storage de conversacion borrada");
            //do not interpret a second cfp in an ongoing conversation
            if (isDebugEnabled()) { debug("#" + conversation_ID.intValue() + ": second cfp."); };
            goMsg_Dest(constant.MSG_Reject,
            currentMessage.createReply(ownID, constant.MSG_Reject, currentMessage.switchDocumentType(), -1),
            currentMessage.sender_hp);
            Conversation currentConversation = (Conversation) negotiations.get(conversation_ID);
            currentConversation.setLastSentMessage(replyMsg);
            currentConversation.setLastReceivedMessage(currentMessage);
            negotiations.put(conversation_ID, currentConversation);
            return false;
        }
        
        // INBOX-Stack
        if (isNegotiating()) {
            addPendingNegotiation(currentMessage);
            return false;
        }
        else {
            //            setNegotiating(true);
            setNegotiating(conversation_ID.intValue());
        }
        
        if (currentMessage.total_requests == 0) {
{
//debug("mem - err - no requests so we reject");    
            Msg reject_msg = new Msg();
            reject_msg.broadcast=false;
            reject_msg.verdict = constant.MSG_Reject;
            reject_msg.setConversation_ID(currentMessage.getConversation_ID());
            reject_msg.itemID = 1;
            reject_msg.receiver_hp=new Hp(currentMessage.sender_hp);
            reject_msg.sender_hp=new Hp(LOCALHP);
            goMsg_Dest(constant.MSG_Reject, reject_msg, reject_msg.receiver_hp);
}
            setNegotiating(false);
            if (anyPendingNegotiation()) {
                interpretCfp(getNextPendingNegotiation());
            } else {
                idleComputing();
            }
            return false;
        }
        
        double hisCurrentProposal, ownCurrentProposal;
// *** [ Start of Pau's stuff ] *********************************
//debug("migr - cfp - Local\t - Total Requests/Satisfied Requests/Unsatisfied Requests/Gain/Costs: "+last_total_requests+"/"+last_total_contracts+"/"+"?"+"/"+last_estimated_gain+"/"+current_costs);
//debug("migr - cfp - R(" +currentMessage.sender_hp.h+ ")\t - Total Requests/Satisfied Requests/Unsatisfied Requests/Gain/Costs: "+currentMessage.total_requests+"/"+currentMessage.sat_requests+"/"+currentMessage.unsat_requests+"/"+"?"+"/"+currentMessage.price);
        
        /* First we check the number of SC that are on our resource */
        int nSCs = 0;
        Resource ourR = (Resource) this.getParent().getComponent("resource");
        Set scSet = ourR.knownServiceCopies.keySet();
        Iterator scIt = scSet.iterator();
        while(scIt.hasNext()) {
            Long currSCkey = (Long)scIt.next();
            Long currSCitemID = (Long)ourR.knownServiceCopies.get(currSCkey);
            if (currSCitemID.longValue() == currentMessage.SC_itemID)
                nSCs++;
        }
//debug("migr - cfp - tenemos " + nSCs + " SCs");
//debug("migr - cfp - R(" +currentMessage.sender_hp.h+ ") tiene " + currentMessage.numSCs + " SCs");

        /* Then we calculate our server percent, in case we don't have requests we set it to a high
            value so it's esasy to migrate (remember we don't have requests)*/
        boolean interesting = true;
        double localPercent;
        if (last_total_requests != 0)
            localPercent = (double)last_total_contracts/(double)last_total_requests;
        else
            localPercent = 1; //?!
        double remotePercent = (double)currentMessage.sat_requests/(double)currentMessage.total_requests;
//debug("migr - cfp - Local Percent/Remote Percent - " + localPercent + "/" + remotePercent);
        double expectedRemotePercent;
        if (currentMessage.numSCs == 0)
            expectedRemotePercent = localPercent*nSCs;
        else
            expectedRemotePercent = (localPercent - remotePercent)/nSCs + remotePercent/(currentMessage.numSCs + 1);
//debug("migr - cfp - Expected Remote Percent - " + expectedRemotePercent);
        double expectedRemoteGain;
        if (last_total_contracts != 0) {
            expectedRemoteGain = expectedRemotePercent*currentMessage.total_requests*(last_estimated_gain/last_total_contracts) + current_costs - currentMessage.price;
//debug("migr - cfp - Expected Remote Gain - " + expectedRemoteGain + " - based on local info");
        } else {
            double expectedLocalGain = strategy.getAveragePrice(new Integer(currentMessage.itemID)) - strategy.getAveragePrice(new Integer(0))*1.0;
            expectedRemoteGain = expectedRemotePercent*currentMessage.total_requests*expectedLocalGain + current_costs - currentMessage.price;
//debug("migr - cfp - Expected Remote Gain - " + expectedRemoteGain + " - based on expected info - " + expectedLocalGain);
        }
        
        if (expectedRemoteGain < last_estimated_gain) {
//debug("migr - so we decide we are not interested in migrating");
{
//debug("mem - err - we are not intersested in migrating so we reject");    
            Msg reject_msg = new Msg();
            reject_msg.broadcast=false;
            reject_msg.verdict = constant.MSG_Reject;
            reject_msg.setConversation_ID(currentMessage.getConversation_ID());
            reject_msg.itemID = 1;
            reject_msg.receiver_hp=new Hp(currentMessage.sender_hp);
            reject_msg.sender_hp=new Hp(LOCALHP);
            goMsg_Dest(constant.MSG_Reject, reject_msg, reject_msg.receiver_hp);
}
            setNegotiating(false);
            if (anyPendingNegotiation()) {
                interpretCfp(getNextPendingNegotiation());
            } else {
                idleComputing();
            }
            return true;
        }
        else {
//debug("migr - so we decide we will try to migrate");
        }
// *** [ End of Pau's stuff ] *********************************
        hisCurrentProposal=((estimated_gain-current_costs)*Math.exp(currentMessage.unsat_requests/currentMessage.total_requests)) - currentMessage.price;
        ownCurrentProposal=((estimated_gain-current_costs)*Math.exp(currentMessage.unsat_requests/currentMessage.total_requests)) - strategy.getLowerLimitPrice(new Integer(1));
//debug("migr - cfp - his/own: "+hisCurrentProposal+"/"+ownCurrentProposal);
        
double myNewPrice = strategy.bargain(factorID, currentMessage.switchDocumentType(), currentMessage.price, -1, conversation_ID);
//double myNewPrice = strategy.bargain(factorID, currentMessage.switchDocumentType(), hisCurrentProposal, ownCurrentProposal, conversation_ID);
        //        double myNewPrice = strategy.bargain(factorID, currentMessage.switchDocumentType(), currentMessage.price, -1, conversation_ID);
        if (isDebugEnabled()) { debug("Agent " + ownID + "| Conv: " + conversation_ID.intValue() + ": myNewPrice in interpretCFP: " + myNewPrice); };
        switch (strategy.getRecommendedAction()) {
            case constant.MSG_Proposal:
                replyMsg = currentMessage.createReply(ownID, constant.MSG_Proposal, currentMessage.switchDocumentType(), myNewPrice);
                break;
            case constant.MSG_Reject:
                replyMsg = currentMessage.createReply(ownID, constant.MSG_Reject, currentMessage.switchDocumentType(), myNewPrice);
                break;
            case constant.MSG_Accept:
                replyMsg = currentMessage.createReply(ownID, constant.MSG_Accept, currentMessage.switchDocumentType(), myNewPrice);
                break;
            /*
             *  default:
             *  replyMsg = currentMessage.createReply(ownID, constant.MSG_Reject, currentMessage.switchDocumentType(), myNewPrice);
             *  break;
             */
        }
        replyMsg.sender_hp=LOCALHP;
        if (isDebugEnabled()) { debug("Agent " + ownID + "| Conv: " + conversation_ID.intValue() + ": replyMsg = " + replyMsg + ", curMsg= " + currentMessage); };
        store.log(CLASS_NAME, constant.log_business, METHOD_NAME, ownID, this.LOCALHP.p, conversation_ID, "Agent "+ownID+": CfP received, proposing "+myNewPrice);
        Conversation currentConversation=new Conversation(conversation_ID);
        currentConversation.setLastSentMessage(replyMsg);
        currentConversation.setLastReceivedMessage(currentMessage);
        negotiations.put(conversation_ID, currentConversation);
        goMsg_Dest(replyMsg.verdict, replyMsg, replyMsg.receiver_hp);
        
        
        // INBOX-Stack
        if (replyMsg.verdict == constant.MSG_Reject) {
            setNegotiating(false);
            if (anyPendingNegotiation()) {
                interpretCfp(getNextPendingNegotiation());
            } else {
                idleComputing();
            }
        }
        else if (replyMsg.verdict == constant.MSG_Accept)
            postAcceptanceMethod(currentMessage);
        //if (negotiations.containsKey(conversation_ID)) {if (isDebugEnabled()) { debug("sss2"); };};
        return done;
    }
}
