package catnet.strategy;

/**
 *  berschrift: B2B-OS Beschreibung: Business-to-Business Operating Multiagent
 *  System Copyright: Copyright (c) 2002 Organisation: IIG Telematik,
 *  Albert-Ludwigs-Universitaet Freiburg
 *
 *@author Torsten Eymann
 *@created    29. Oktober 2002
 *@version    1.0
 */

public class Recommendation {

    /**
     *  Constructor for the Recommendation object
     *
     *@param  p  Description of the Parameter
     *@param  a  Description of the Parameter
     *@param  e  Description of the Parameter
     */
    public Recommendation(int action, double price, String state) {
        this.price = price;
        this.recommendedAction = action;
        this.executionState = state;
    }


    /**
     *  Description of the Field
     */
    private int recommendedAction;
    /**
     *  Description of the Field
     */
    private String executionState;
    /**
     *  Description of the Field
     */
    private double price;


    /**
     *  Gets the recommendedAction attribute of the Recommendation object
     *
     *@return    The recommendedAction value
     */
    public int getRecommendedAction() {
        return recommendedAction;
    }


    /**
     *  Gets the executionState attribute of the Recommendation object
     *
     *@return    The executionState value
     */
    public String getExecutionState() {
        return executionState;
    }


    /**
     *  Gets the price attribute of the Recommendation object
     *
     *@return    The price value
     */
    public double getPrice() {
        return price;
    }


    /**
     *  Sets the executionState attribute of the Recommendation object
     *
     *@param  executionState  The new executionState value
     */
    public void setExecutionState(String executionState) {
        this.executionState = executionState;
    }
}
