package catnet.strategy;

import java.io.*;
/**
 *  berschrift: B2B-OS Beschreibung: Copyright: Copyright (c) 2002
 *  Organisation: IIG Telematik, Albert-Ludwigs-Universitaet Freiburg <p>
 *
 *  This class attempts to load a strategy class according to a given value of
 *  the &lt;strategy_module&gt; parameter in the Agent.cfg file. However, it
 *  does not work at the moment, as I have not worked out how to address classes
 *  in subpackages or subdirectories. It is provided as a blueprint for further
 *  development anyway.
 *
 *@author     Dr. Torsten Eymann
 *@created    3. Mai 2002
 *@version    1.0
 */

public class StrategyClassLoader extends ClassLoader {

    /**
     *  Description of the Method
     *
     *@param  name     Description of the Parameter
     *@param  resolve  Description of the Parameter
     *@return          Description of the Return Value
     */
    public synchronized Class loadClass(String name, boolean resolve) {
        Class c = findLoadedClass(name);
        if (c != null) {
            return c;
        }
        try {
            c = findClass(name);
            if (c != null) {
                return c;
            }
        } catch (ClassNotFoundException e) {
            System.err.println("Strategy file " + name + " could not be found in classpath");
        }
        try {
            c = findSystemClass(name);
            if (c != null) {
                return c;
            }
        } catch (ClassNotFoundException e) {}
        try {
            RandomAccessFile file = new RandomAccessFile(name + ".class", "r");
            byte data[] = new byte[(int) file.length()];
            file.readFully(data);
            c = defineClass(name, data, 0, data.length);
        } catch (IOException e) {
            System.err.println("Strategy file " + name + ".class could not be found");
        }
        if (resolve) {
            resolveClass(c);
        }
        return c;
    }
}
