/*
 * TimeComputeRAEFromFile.java
 *
 * Created on 15 de enero de 2003, 16:43
 */

package catnet.util;

import catnet.util.*;
import catnet.util.TimeComputingNetInfo.*;
import java.io.*;

/**
 *
 * @author  partigas
 */
public class TimeComputeNetInfoFromFile {
    
    /** Creates a new instance of TimeComputeRAEFromFile */
    public TimeComputeNetInfoFromFile() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        String nameFile;
        File newFile;
        LineNumberReader lnr;
        FileReader fr;
        int msBetweenComps, msDataLives;
        
        if (args.length < 2)
        {
            System.out.println("Usage: TimeComputeNetInfoFromFile [Data File] [Output File]");
            return;
        }
        else if (args.length == 2)
        {
            msBetweenComps = 1000;
            msDataLives = 0;
        }
        else if (args.length == 3)
        {
            msBetweenComps = Integer.valueOf(args[2]).intValue();
            msDataLives = 0;
        }
        else 
        {
            msBetweenComps = Integer.valueOf(args[2]).intValue();
            msDataLives = Integer.valueOf(args[3]).intValue();
        }
        
        TimeComputingNetInfo tcompute = new TimeComputingNetInfo(args[1], msBetweenComps, msDataLives);
        try {
            newFile = new File(args[0]);
            fr = new FileReader(newFile);
            lnr = new LineNumberReader(fr);
            
            float time;
            
            String str;
            while((str = lnr.readLine()) != null) {
                String[] strlist = str.split(new String("\\s"));
                time = Float.valueOf(strlist[0]).floatValue();
                NetInfoData currData = tcompute.new NetInfoData();
                currData.hops = Integer.valueOf(strlist[1]).intValue();
                currData.type = Integer.valueOf(strlist[2]).intValue();
                currData.size = Integer.valueOf(strlist[3]).intValue();
                tcompute.addData(time, currData);
            };
            lnr.close();
            fr.close();
            
            tcompute.computeAll();
        }
        catch (FileNotFoundException fnfe) {
        }
        catch (IOException e) {
        };
    }    
}
