package catnet.util;

import java.util.*;
import drcl.comp.Component;
import catnet.data.constant;
import catnet.util.TM_EVT;

/**
 *
 * @author  partigas
 */
public abstract class TimeComputing /*extends drcl.net.Module*/ {
    
    TreeMap sortedData;
    float sBetweenComps, sDataLives;
    
    /** Creates a new instance of TimeComputing */
    public TimeComputing(int in_msBetweenComps, int in_msDataLives) {
        sBetweenComps = in_msBetweenComps/1000;
        sDataLives = java.lang.Math.max(in_msDataLives/1000, in_msBetweenComps/1000);
        sortedData = new TreeMap();
    }
    
    public TimeComputing(int in_msBetweenComps) {
        sBetweenComps = in_msBetweenComps/1000;
        sDataLives = sBetweenComps;
        sortedData = new TreeMap();
    }
    
    public void addData(float time, Object data) {
        sortedData.put(new Float(time), data);
    }
    
    public void computeAll() {
        float currTime = 0;
        while(! sortedData.isEmpty()) {
            if (currTime >= java.lang.Math.max(sDataLives, sBetweenComps)) {
                Float startF = new Float(currTime - sDataLives);
                Float endF = new Float(currTime);
                SortedMap tmpMap = (SortedMap) sortedData.subMap(startF, endF);
                computeData(currTime, tmpMap);
                Float startD = new Float(0);
                Float endD = new Float(currTime - sDataLives);
                SortedMap delMap = (SortedMap) sortedData.subMap(startD, endD);
                cleanData(delMap);
            }
            currTime += sBetweenComps;
        }
    }
/*    
    public void startComputing() {        
        double now_ = getTime();
        double time_ = now_ + new Float(msBetweenComps).floatValue();
        TM_EVT computeEvent = null;
        computeEvent = new TM_EVT(constant.TIME_COMPUTE, 0, time_);
        setTimeoutAt(computeEvent, time_);
    }
    
    protected synchronized void timeout(Object evt_) {
        int resourceId = ((TM_EVT)evt_).resourceid;
        double timeout = ((TM_EVT)evt_).timeout;
        //debug("agent "+resourceId+": timeout  "+timeout);
        
        // Check if timeout was being reset or cancelled
        if (Double.isNaN(timeout))
            return;
        // XX: rounding error if in real-time simulation?
        if (timeout > getTime()) {
            setTimeoutAt(evt_, timeout);
            return;
        }
        
        switch(((TM_EVT)evt_).type) {
            case constant.TIME_COMPUTE:
                // We dont compute until we have enough data
                if (getTime() < msDataLives)
                    return;
                SortedMap currMap = sortedData.subMap(new Float(getTime() - msBetweenComps),new Float(getTime()));
                computeData((float) getTime(), currMap);
                cleanData(currMap);
                startComputing();
                break;
        }
    }
*/    
    public void cleanData(SortedMap data2Clean) {
        Set delKeys = data2Clean.keySet();
        Iterator itKeys = delKeys.iterator();
        LinkedList tmpList = new LinkedList();
        
        while (itKeys.hasNext())
            tmpList.add(itKeys.next());
        
        for (int i=0; i<tmpList.size(); i++)
            sortedData.remove(tmpList.get(i));
    }
    
    public abstract void computeData(float currTime, SortedMap currData);
}
