package catnet.util;

import catnet.util.TimeComputing;
import java.util.*;
import java.io.*;


/**
 *
 * @author  partigas
 */
public class TimeComputingNetInfo extends catnet.util.TimeComputing {
    
    public class NetInfoData {
        public int hops, type, size;
    };
    
    FileWriter fw;
    BufferedWriter bw;
    File fichero;
    String fileName;
    int totalPackets = 0;
    int totalHops = 0;
    
    public void addData(float time, Object data) {
        totalPackets++;
        totalHops += ((NetInfoData) data).hops + 1;
        super.addData(time, data);
    }
    
    public TimeComputingNetInfo(String in_fileName, int in_msBetweenComps, int in_msDataLives) {
        super(in_msBetweenComps, in_msDataLives);
        fileName = in_fileName;
    }
    
    public TimeComputingNetInfo(String in_fileName, int in_msBetweenComps) {
        super(in_msBetweenComps);
        fileName = in_fileName;
    }
    
    protected void openFile() {
        try {
            fichero = new File(fileName);
            fw = new FileWriter(fichero);
            bw = new BufferedWriter(fw);
        }
        catch (Exception e) {
        }
        
    }
    
    protected void closeFile() {
        try {
            bw.close();
        }
        catch(Exception e) {
        }
    }
    
    public void computeAll() {
        openFile();
        super.computeAll();
        closeFile();
    }
    
    public void computeData(float currTime, SortedMap currData) {
        int nPackets = 0;
        int nHops = 0;
        Set currKeys = currData.keySet();
        Iterator itKeys = currKeys.iterator();
        
        while (itKeys.hasNext()) {
            NetInfoData currNetData = (NetInfoData) sortedData.get(itKeys.next());
            nPackets++;
            nHops += currNetData.hops + 1;
        }
        
        try {
            bw.write(currTime + "\t" + nPackets + "\t" + nHops+ "\t" + totalPackets + "\t" + totalHops  + "\r\n");
        }
        catch(Exception e) {
        }
    }
}
