package catnet.util;

import catnet.util.TimeComputing;
import java.util.*;
import java.io.*;


/**
 *
 * @author  partigas
 */
public class TimeComputingRAE extends catnet.util.TimeComputing {
    
    FileWriter fw;
    BufferedWriter bw;
    File fichero;
    String fileName;
    int totalServed = 0;
    int totalNotServed = 0;
    
    /** Creates a new instance of TimeComputingRAE */
    public TimeComputingRAE(String in_fileName, int in_msBetweenComps, int in_msDataLives) {
        super(in_msBetweenComps, in_msDataLives);
        fileName = in_fileName;
    }
    
    public TimeComputingRAE(String in_fileName, int in_msBetweenComps) {
        super(in_msBetweenComps);
        fileName = in_fileName;
    }
    
    public void addData(float time, Object data) {
        if (((Integer) data).intValue() == 0)
            totalNotServed++;
        else
            totalServed++;
        super.addData(time, data);
    }
    
    protected void openFile() {
        try {
            fichero = new File(fileName);
            fw = new FileWriter(fichero);
            bw = new BufferedWriter(fw);
        }
        catch (Exception e) {
        }
        
    }
    
    protected void closeFile() {
        try {
            bw.close();
        }
        catch(Exception e) {
        }
    }
    
    public void computeAll() {
        openFile();
        super.computeAll();
        closeFile();
    }
    
    public void computeData(float currTime, SortedMap currData) {
        int nDemands = 0;
        int numServed = 0;
        int numNotServed = 0;
        float totalPercent = totalServed*100/(totalServed + totalNotServed);
        Set currKeys = currData.keySet();
        Iterator itKeys = currKeys.iterator();
        
        while (itKeys.hasNext())
            if (((Integer) sortedData.get(itKeys.next())).intValue() == 1)
                numServed++;
            else
                numNotServed++;
        nDemands = numServed + numNotServed;
        if (nDemands > 0) {
            float percent = numServed*100/nDemands;
            try {
                bw.write(currTime + "\t" + percent + "\t" + totalPercent + "\r\n");
            }
            catch(Exception e) {
            }
        }
    }
    
}
