package catnet.learning.stdea;

import java.util.*;
import java.io.*;

/**
 *  A generic gene object, e.g. a binary or a float value. It is possible to
 *  read and write the gene value, to initalize it randomly and to mutate it.
 *
 *@author     Robert E. Smith, Immi
 *@created    1. Januar 2002
 */
public abstract class Gene implements IMutateable, IRandomizeable, Cloneable, Serializable {
    /**
     *  The value of the gene, depending on the class derived from this class.
     */
    protected Object geneValue;


    /**
     *  a public version of clone()
     *
     *@return    Description of the Return Value
     */
    public Gene replica() {
        try {
            return (Gene) clone();
        } catch (Exception e) {
            System.out.println("Gene.replica(): Error replicating gene " + e);
        }
        return null;
    }


    /**
     *@return    geneValue
     */
    public final Object getGeneValue() {
        return geneValue;
    }


    /**
     *@param  value  should be Boolean
     */
    public final void setGeneValue(Object value) {
        geneValue = value;
        // ((Boolean) value).booleanValue();
    }


    /**
     *  Method declaration
     *
     *@return
     *@see
     */
    public String toString() {
        return geneValue.toString();
    }
}
